;----------------------------------------------------------------------------------------------------------------------------------------------------;
;  U7VXD.ASM                                                                                                                                         ;
;    Assistant VXD to Display the Win 95/98 Machine state, Used by U7RUN.COM                                                                         ;
;    Gilbert ROUQUI, August 1, 2000                                                                                                                 ;
;----------------------------------------------------------------------------------------------------------------------------------------------------;

;====================================================================================================================================================;

                              title                         U7VXD - U7VXD VxD
                              name                          U7VXD.vxd

;====================================================================================================================================================;
;                             I N C L U D E S
;====================================================================================================================================================;

                              .586p
                              .xlist
                              include                       vmm.inc
                              include                       vwin32.inc
                              include                       shell.inc
                              include                       ifsmgr.inc
                              .list

;====================================================================================================================================================;
;                             E Q U A T E S
;====================================================================================================================================================;

U7VXD_MAJOR_VERSION           EQU                           1
U7VXD_MINOR_VERSION           EQU                           0

;====================================================================================================================================================;
;                             M A C R O S
;====================================================================================================================================================;

;====================================================================================================================================================;
;                             P U B L I C                   D A T A
;====================================================================================================================================================;

VXD_LOCKED_DATA_SEG

;====================================================================================================================================================;
; To produce a Message Box from a VXD
; VxdCaption                  db                            "VxD Trace",0
; VxdPageMessage              db                            "                     Page Fault Taken  ....",0
;                             mov                           eax, MB_OK
;                             mov                           ecx, OFFSET32 VxdUnloadMessage
;                             mov                           edi, OFFSET32 VxdCaption
;                             VxDCall                       SHELL_SYSMODAL_Message
;                             int                           3
;====================================================================================================================================================;

callback_type_run             db                            10h dup(0c3h)

IFDEF TEST_NONNULLDS
VXD_GS_PM                     dw                            0
VXD_GS_V86                    dw                            0
ENDIF

VXD_VMHandle                  dd                            0
VXD_BlockAddress              dd                            0
VXD_BlockSize                 dd                            0
VXD_ProgramBase               dd                            0

IFDEF TEST_CATCHFAULT
DumpHandle                    dd                            0
DumpOffset                    dd                            0
DumpFrame                     dd                            0
ENDIF

VXD_CurrentProgram            db                            0
VXD_IsBGIntro                 equ                           00h
VXD_IsBGMain                  equ                           01h
VXD_IsBGGame                  equ                           02h
VXD_IsBGEndGame               equ                           03h
VXD_IsSIIntro                 equ                           10h
VXD_IsSIMain                  equ                           11h
VXD_IsSIGame                  equ                           12h
VXD_IsSIEndGame               equ                           13h

IFDEF TEST_CATCHFAULT
DumpFile                      db                            "\U7VXD.LOG", 0
DumpBuffer                    db                            " = 00000000"
DumpSepar                     db                            ", "
DumpLine                      db                            0dh, 0ah
DumpADR                       db                            "adr"
DumpEAX                       db                            "eax"
DumpEBX                       db                            "ebx"
DumpECX                       db                            "ecx"
DumpEDX                       db                            "edx"
DumpESP                       db                            "esp"
DumpEBP                       db                            "ebp"
DumpESI                       db                            "esi"
DumpEDI                       db                            "edi"
DumpEIP                       db                            "eip"
DumpBAS                       db                            "bas"
DumpEFLAGS                    db                            "flg"
DumpINS                       db                            "ins"
DumpIN2                       db                            "in2"
DumpARG                       db                            "arg"
DumpDS                        db                            "ds"
DumpES                        db                            "es"
DumpSS                        db                            "ss"
DumpCS                        db                            "cs"
DumpFS                        db                            "fs"
DumpGS                        db                            "gs"
DumpBLK                       db                            "    "
DumpVMM                       db                            "VMM "
DumpV86                       db                            "V86 "

DumpRow                       db                            512 dup (20h)

ACTION_OPENALWAYS             equ                           0011h
ACCESS_READWRITE              equ                           0002h
SHARE_DENYWRITE               equ                           0020h
R0_OPENCREATFILE              equ                           0D500h
R0_READFILE                   equ                           0D600h
R0_WRITEFILE                  equ                           0D601h
R0_CLOSEFILE                  equ                           0D700h
R0_GETFILESIZE                equ                           0D800h
ENDIF

;====================================================================================================================================================;
;
; U7VXD The Patch Table
;
;====================================================================================================================================================;

u71_main_patch                dw                            17D9h
                              dw                            14D7h-17D9h
                              dw                            0071h, 0080h, 008Bh, 00D9h, 0112h, 0152h, 01D7h, 01D9h
                              dw                            0252h, 0254h, 0288h, 02B8h, 02E3h, 030Dh, 0337h, 0361h
                              dw                            03A2h, 03EEh, 03F6h, 0433h, 043Bh, 0498h, 04A2h, 04F6h
                              dw                            0500h, 05BFh, 05D1h, 05E6h, 05F0h, 05FBh, 0650h, 065Ah
                              dw                            06B0h, 06BAh, 0704h, 0748h, 078Eh, 07CCh, 07CFh, 07D2h
                              dw                            07D5h, 07D8h, 07DBh, 07DEh, 07E1h, 07E4h, 07E7h, 07EAh
                              dw                            07EDh, 07F0h, 07F3h, 07F6h, 07F9h, 07FCh, 07FFh, 0802h
                              dw                            0805h, 0808h, 080Bh, 080Eh, 0811h, 0814h, 0817h, 081Ah
                              dw                            081Dh, 0820h, 0823h, 0826h, 0829h, 082Ch, 082Fh, 0832h
                              dw                            0835h, 0838h, 083Bh, 083Eh, 0841h, 0844h, 0847h, 084Ah
                              dw                            084Dh, 0850h, 0853h, 0856h, 0859h, 085Ch, 085Fh, 0862h
                              dw                            0865h, 0868h, 086Bh, 086Eh, 0871h, 0874h, 0877h, 087Ah
                              dw                            087Dh, 0880h, 0883h, 0886h, 0889h, 088Ch, 088Fh, 0892h
                              dw                            0895h, 0898h, 089Bh, 089Eh, 08A1h, 08A4h, 08A7h, 08AAh
                              dw                            08ADh, 08B0h, 08B3h, 08B6h, 08B9h, 0922h, 0924h, 0926h
                              dw                            0967h, 0A2Eh, 0A36h, 0A46h, 0A52h, 0ABCh, 0ACFh, 0AEEh
                              dw                            0AF9h, 0B02h, 0B0Ah, 0B65h, 0BE5h, 0BF6h, 0C0Fh, 0C14h
                              dw                            0C1Fh, 0C25h, 0C33h, 0C5Bh, 0C86h, 0C9Eh, 0CE9h, 0D00h
                              dw                            0D09h, 0E4Eh, 0E65h, 0E6Eh, 0F08h, 0F18h, 0F37h, 0F3Ch
                              dw                            0F4Ah, 0F50h, 0F61h, 0F8Ch, 0FBDh, 0FD8h, 1026h, 103Dh
                              dw                            1046h, 1189h, 11A0h, 11A9h, 1258h, 1269h, 1273h, 1283h
                              dw                            1291h, 129Ch, 12B4h, 12C6h, 12D1h, 12E4h, 12FFh, 1309h
                              dw                            1314h, 1325h, 132Eh, 133Bh, 1349h, 1352h, 1364h, 1380h
                              dw                            1389h, 13C7h, 1403h, 140Ch, 141Ch, 1425h, 1432h, 143Bh
                              dw                            147Dh, 14B5h, 14C8h, 14D1h, 14DFh, 14EDh, 14F6h, 1505h
                              dw                            1544h, 1557h, 1560h, 156Eh, 157Ch, 1585h, 15DBh, 15E4h
                              dw                            16AFh, 16C0h, 16CAh, 16DAh, 16E8h, 16F3h, 170Bh, 171Dh
                              dw                            1728h, 173Bh, 175Ch, 1760h, 1779h, 177Ch, 1782h, 1797h
                              dw                            17AFh, 17B3h, 17CCh, 17CFh, 17D5h, 17F8h, 17FCh, 1806h
                              dw                            1818h, 181Bh, 181Dh, 183Eh, 185Ah, 1863h, 18A0h, 18E3h
                              dw                            18E7h, 1900h, 1903h, 1909h, 1929h, 192Dh, 1946h, 1949h
                              dw                            194Fh, 1965h, 196Eh, 19B0h, 19E8h, 1A02h, 1A06h, 1A1Fh
                              dw                            1A22h, 1A28h, 1A4Ch, 1A50h, 1A5Ah, 1A6Ch, 1A6Fh, 1A71h
                              dw                            1A8Fh, 1ACCh, 1ADFh, 1AE8h, 1AF6h, 1B04h, 1B0Dh, 1B68h
                              dw                            1B6Ch, 1B85h, 1B88h, 1B8Eh
                              dw                            0

u71_game_patch                dw                            3FC8h
                              dw                            0B49h-3FC8h
                              dw                            0027h, 0033h, 0066h, 0072h, 00A5h, 00A9h, 00DCh, 0114h
                              dw                            0117h, 0163h, 0166h
                              dw                            0FD5h-3FC8h
                              dw                            0043h, 004Dh, 0057h, 00EBh, 00F0h, 011Ah, 011Fh, 0161h
                              dw                            0166h, 0196h, 01CAh, 01CFh, 01E1h, 01E6h, 022Ah, 0244h
                              dw                            024Fh, 0266h, 027Ah, 028Ah, 029Bh, 02A6h, 02D5h, 02E7h
                              dw                            0338h, 0342h, 034Ch, 03DFh, 03E7h, 03EFh, 0472h, 047Eh
                              dw                            048Ah, 04C1h, 04C8h, 04FDh, 0504h, 0538h, 053Fh, 0550h
                              dw                            059Eh, 05DFh, 05E7h, 05EAh, 060Bh, 0624h, 0629h, 0634h
                              dw                            06A6h, 06A9h, 06AFh, 06B2h, 06B8h, 06BBh, 06C1h, 06C4h
                              dw                            06CAh, 06CDh, 06D3h, 06D6h, 06DCh, 06DFh, 06E5h, 06E8h
                              dw                            0761h, 0770h, 077Bh, 07C9h, 0802h, 087Ch, 0882h, 0886h
                              dw                            0890h, 0894h, 08A1h, 08A7h, 08AAh, 08B3h, 08B6h, 08C3h
                              dw                            08C6h, 08CAh, 08CEh, 08D1h, 08D7h, 08DFh, 08F4h, 0911h
                              dw                            0982h, 0A07h, 0A09h, 0A82h, 0A84h, 0AB8h, 0AE8h, 0B13h
                              dw                            0B3Dh, 0B67h, 0B91h, 0BD2h, 0C1Eh, 0C26h, 0C63h, 0C6Bh
                              dw                            0CC8h, 0CD2h, 0D26h, 0D30h, 0DEFh, 0E01h, 0E16h, 0E20h
                              dw                            0E2Bh, 0E80h, 0E8Ah, 0EE0h, 0EEAh, 0F34h, 0F78h, 0FBEh
                              dw                            0FFCh, 0FFFh, 1002h, 1005h, 1008h, 100Bh, 100Eh, 1011h
                              dw                            1014h, 1017h, 101Ah, 101Dh, 1020h, 1023h, 1026h, 1029h
                              dw                            102Ch, 102Fh, 1032h, 1035h, 1038h, 103Bh, 103Eh, 1041h
                              dw                            1044h, 1047h, 104Ah, 104Dh, 1050h, 1053h, 1056h, 1059h
                              dw                            105Ch, 105Fh, 1062h, 1065h, 1068h, 106Bh, 106Eh, 1071h
                              dw                            1074h, 1077h, 107Ah, 107Dh, 1080h, 1083h, 1086h, 1089h
                              dw                            108Ch, 108Fh, 1092h, 1095h, 1098h, 109Bh, 109Eh, 10A1h
                              dw                            10A4h, 10A7h, 10AAh, 10ADh, 10B0h, 10B3h, 10B6h, 10B9h
                              dw                            10BCh, 10BFh, 10C2h, 10C5h, 10C8h, 10CBh, 10CEh, 10D1h
                              dw                            10D4h, 10D7h, 10DAh, 10DDh, 10E0h, 10E3h, 10E6h, 10E9h
                              dw                            1152h, 1154h, 1156h, 1197h, 125Eh, 1266h, 1276h, 1282h
                              dw                            12EBh, 12F8h, 1380h, 1393h, 13B2h, 13BDh, 13C6h, 13CEh
                              dw                            1429h, 14A9h, 14BAh, 14D3h, 14D8h, 14E3h, 14E9h, 14F7h
                              dw                            151Fh, 154Ah, 1562h, 15ADh, 15C4h, 15CDh, 1712h, 1729h
                              dw                            1732h, 17CCh, 17DCh, 17FBh, 1800h, 180Eh, 1814h, 1825h
                              dw                            1850h, 1881h, 189Ch, 18EAh, 1901h, 190Ah, 1A4Dh, 1A64h
                              dw                            1A6Dh, 1B02h, 1B14h, 1B29h, 1B33h, 1B3Eh, 1BD4h, 1BE5h
                              dw                            1BEFh, 1BFFh, 1C0Dh, 1C18h, 1C30h, 1C42h, 1C4Dh, 1C60h
                              dw                            1C7Bh, 1C85h, 1C90h, 1CA1h, 1CAAh, 1CB7h, 1CC5h, 1CCEh
                              dw                            1CE0h, 1CFCh, 1D05h, 1D43h, 1D7Fh, 1D88h, 1D98h, 1DA1h
                              dw                            1DAEh, 1DB7h, 1DF9h, 1E31h, 1E44h, 1E4Dh, 1E5Bh, 1E69h
                              dw                            1E72h, 1E81h, 1EC0h, 1ED3h, 1EDCh, 1EEAh, 1EF8h, 1F01h
                              dw                            1F57h, 1F60h, 2004h, 2015h, 201Fh, 2030h, 203Eh, 2049h
                              dw                            2063h, 2074h, 2087h, 2091h, 20A7h, 20BAh, 20C7h, 20DFh
                              dw                            20E1h, 20FBh, 2117h, 2120h, 2172h, 21B9h, 21D2h, 21E7h
                              dw                            21F0h, 2246h, 2295h, 22A2h, 22B8h, 22BAh, 22D0h, 230Eh
                              dw                            2321h, 232Ah, 2338h, 2346h, 234Fh, 23AAh, 245Fh, 2470h
                              dw                            247Ah, 248Bh, 2499h, 24A4h, 24BEh, 24CFh, 24E5h, 24EFh
                              dw                            2512h, 2515h, 2517h, 252Eh, 2548h, 254Bh, 254Dh, 2576h
                              dw                            2579h, 257Bh, 2599h, 25B5h, 25BEh, 2612h, 2699h, 269Ch
                              dw                            269Eh, 26C7h, 26CAh, 26CCh, 26E4h, 26EDh, 2744h, 278Fh
                              dw                            27A9h, 27ACh, 27AEh, 27D5h, 27D8h, 27DAh, 27F4h, 2834h
                              dw                            2847h, 2850h, 285Eh, 286Ch, 2875h, 28FDh, 2900h, 2902h
                              dw                            29D4h, 29E5h, 29EFh, 2A00h, 2A0Eh, 2A19h, 2A33h, 2A44h
                              dw                            2A5Ah, 2A64h, 2A87h, 2A8Bh, 2AA4h, 2AA7h, 2AADh, 2ACAh
                              dw                            2AE4h, 2AE8h, 2B01h, 2B04h, 2B0Ah, 2B36h, 2B3Ah, 2B44h
                              dw                            2B5Eh, 2B61h, 2B63h, 2B8Ch, 2BA8h, 2BB1h, 2C05h, 2C8Ch
                              dw                            2C90h, 2CA9h, 2CACh, 2CB2h, 2CE0h, 2CE4h, 2CFDh, 2D00h
                              dw                            2D06h, 2D23h, 2D2Ch, 2D84h, 2DCFh, 2DE9h, 2DEDh, 2E06h
                              dw                            2E09h, 2E0Fh, 2E3Bh, 2E3Fh, 2E49h, 2E63h, 2E66h, 2E68h
                              dw                            2E8Dh, 2ECDh, 2EE0h, 2EE9h, 2EF7h, 2F05h, 2F0Eh, 2F96h
                              dw                            2F9Ah, 2FB3h, 2FB6h, 2FBCh, 3097h, 30A8h, 30B2h, 30C2h
                              dw                            30D0h, 30DBh, 30F3h, 3105h, 3110h, 3123h, 3144h, 3148h
                              dw                            3161h, 3164h, 316Ah, 317Fh, 3197h, 319Bh, 31B4h, 31B7h
                              dw                            31BDh, 31E0h, 31E4h, 31EEh, 3200h, 3203h, 3205h, 3226h
                              dw                            3242h, 324Bh, 3288h, 32CBh, 32CFh, 32E8h, 32EBh, 32F1h
                              dw                            3311h, 3315h, 332Eh, 3331h, 3337h, 334Dh, 3356h, 3398h
                              dw                            33D0h, 33EAh, 33EEh, 3407h, 340Ah, 3410h, 3434h, 3438h
                              dw                            3442h, 3454h, 3457h, 3459h, 3477h, 34B4h, 34C7h, 34D0h
                              dw                            34DEh, 34ECh, 34F5h, 3550h, 3554h, 356Dh, 3570h, 3576h
                              dw                            364Bh, 365Ch, 3666h, 3676h, 3684h, 368Fh, 36A7h, 36B9h
                              dw                            36C4h, 36D6h, 36F7h, 36FAh, 36FCh, 370Bh, 3723h, 3726h
                              dw                            3728h, 3739h, 3746h, 3749h, 374Bh, 3761h, 377Dh, 3786h
                              dw                            37C4h, 3807h, 380Ah, 380Ch, 3827h, 382Ah, 382Ch, 383Dh
                              dw                            3846h, 3888h, 38C0h, 38DAh, 38DDh, 38DFh, 38F1h, 38FEh
                              dw                            3901h, 3903h, 3916h, 3953h, 3966h, 396Fh, 397Dh, 398Bh
                              dw                            3994h, 39EFh, 39F2h, 39F4h, 3A61h, 3A7Ah, 3A93h, 3AACh
                              dw                            3AD4h, 3ADEh, 3B18h, 3B31h, 3B4Ah, 3B63h, 3CC7h, 3CE0h
                              dw                            3CFDh, 3D07h, 3D4Fh, 3DD6h, 3DE0h, 3DE3h, 3DE5h
                              dw                            3A02h-3FC8h
                              dw                            0016h, 0023h, 003Ch, 0049h, 0062h
                              dw                            3A09h-3FC8h
                              dw                            0029h, 002Eh, 0033h, 0038h, 003Dh, 0045h, 0049h, 0051h
                              dw                            005Fh, 007Dh, 0082h, 00ABh, 00B5h, 00C6h, 00D2h, 00D9h
                              dw                            00E9h, 0108h, 010Ch, 0126h, 0130h
                              dw                            3A88h-3FC8h
                              dw                            0083h, 0089h, 00A4h, 00C5h, 00CBh
                              dw                            3A95h-3FC8h
                              dw                            0024h, 002Ah, 01A6h, 01D1h, 01EBh, 0209h, 0224h, 022Ah
                              dw                            3ADAh-3FC8h
                              dw                            00FAh, 0141h, 014Ch, 016Ah
                              dw                            0

u71_end_patch                 dw                            13BCh
                              dw                            1290h-13BCh
                              dw                            002Eh, 00B3h, 00B5h, 012Eh, 0130h, 0164h, 0194h, 01BFh
                              dw                            01E9h, 0213h, 023Dh, 027Eh, 02CAh, 02D2h, 030Fh, 0317h
                              dw                            0374h, 037Eh, 03D2h, 03DCh, 049Bh, 04ADh, 04C2h, 04CCh
                              dw                            04D7h, 052Ch, 0536h, 058Ch, 0596h, 05E0h, 0624h, 066Ah
                              dw                            06A8h, 06ABh, 06AEh, 06B1h, 06B4h, 06B7h, 06BAh, 06BDh
                              dw                            06C0h, 06C3h, 06C6h, 06C9h, 06CCh, 06CFh, 06D2h, 06D5h
                              dw                            06D8h, 06DBh, 06DEh, 06E1h, 06E4h, 06E7h, 06EAh, 06EDh
                              dw                            06F0h, 06F3h, 06F6h, 06F9h, 06FCh, 06FFh, 0702h, 0705h
                              dw                            0708h, 070Bh, 070Eh, 0711h, 0714h, 0717h, 071Ah, 071Dh
                              dw                            0720h, 0723h, 0726h, 0729h, 072Ch, 072Fh, 0732h, 0735h
                              dw                            0738h, 073Bh, 073Eh, 0741h, 0744h, 0747h, 074Ah, 074Dh
                              dw                            0750h, 0753h, 0756h, 0759h, 075Ch, 075Fh, 0762h, 0765h
                              dw                            0768h, 076Bh, 076Eh, 0771h, 0774h, 0777h, 077Ah, 077Dh
                              dw                            0780h, 0783h, 0786h, 0789h, 078Ch, 078Fh, 0792h, 0795h
                              dw                            07FEh, 0800h, 0802h, 0843h
                              dw                            1356h-13BCh
                              dw                            00FEh, 0145h, 0150h, 016Eh
                              dw                            0

u72_int_patch                 dw                            13F1h
                              dw                            12C8h-13F1h
                              dw                            003Ah, 00BFh, 00C1h, 013Ah, 013Ch, 0170h, 01A0h, 01CBh
                              dw                            01F5h, 021Fh, 0249h, 028Ah, 02D6h, 02DEh, 031Bh, 0323h
                              dw                            037Fh, 0389h, 03DBh, 03E5h, 04A7h, 04B2h, 0506h, 0510h
                              dw                            0564h, 056Eh, 05B6h, 05F8h, 063Ch, 0678h, 067Bh, 067Eh
                              dw                            0681h, 0684h, 0687h, 068Ah, 068Dh, 0690h, 0693h, 0696h
                              dw                            0699h, 069Ch, 069Fh, 06A2h, 06A5h, 06A8h, 06ABh, 06AEh
                              dw                            06B1h, 06B4h, 06B7h, 06BAh, 06BDh, 06C0h, 06C3h, 06C6h
                              dw                            06C9h, 06CCh, 06CFh, 06D2h, 06D5h, 06D8h, 06DBh, 06DEh
                              dw                            06E1h, 06E4h, 06E7h, 06EAh, 06EDh, 06F0h, 06F3h, 06F6h
                              dw                            06F9h, 06FCh, 06FFh, 0702h, 0705h, 0708h, 070Bh, 070Eh
                              dw                            0711h, 0714h, 0717h, 071Ah, 071Dh, 0720h, 0723h, 0726h
                              dw                            0729h, 072Ch, 072Fh, 0732h, 0735h, 0738h, 073Bh, 073Eh
                              dw                            0741h, 0744h, 0747h, 074Ah, 074Dh, 0750h, 0753h, 0756h
                              dw                            0759h, 075Ch, 075Fh, 0762h, 0765h, 07CCh, 07CEh, 07D0h
                              dw                            080Fh
                              dw                            138Bh-13F1h
                              dw                            00FAh, 013Eh, 0149h, 0167h
                              dw                            0

u72_main_patch                dw                            1821h
                              dw                            14BEh-1821h
                              dw                            006Dh, 007Ch, 0087h, 00D5h, 010Eh, 014Eh, 01D3h, 01D5h
                              dw                            024Eh, 0250h, 0284h, 02B4h, 02DFh, 0309h, 0333h, 035Dh
                              dw                            039Eh, 03EAh, 03F2h, 042Fh, 0437h, 0494h, 049Eh, 04F2h
                              dw                            04FCh, 05BBh, 05CDh, 05E2h, 05ECh, 05F7h, 064Ch, 0656h
                              dw                            06ACh, 06B6h, 0700h, 0744h, 078Ah, 07C8h, 07CBh, 07CEh
                              dw                            07D1h, 07D4h, 07D7h, 07DAh, 07DDh, 07E0h, 07E3h, 07E6h
                              dw                            07E9h, 07ECh, 07EFh, 07F2h, 07F5h, 07F8h, 07FBh, 07FEh
                              dw                            0801h, 0804h, 0807h, 080Ah, 080Dh, 0810h, 0813h, 0816h
                              dw                            0819h, 081Ch, 081Fh, 0822h, 0825h, 0828h, 082Bh, 082Eh
                              dw                            0831h, 0834h, 0837h, 083Ah, 083Dh, 0840h, 0843h, 0846h
                              dw                            0849h, 084Ch, 084Fh, 0852h, 0855h, 0858h, 085Bh, 085Eh
                              dw                            0861h, 0864h, 0867h, 086Ah, 086Dh, 0870h, 0873h, 0876h
                              dw                            0879h, 087Ch, 087Fh, 0882h, 0885h, 0888h, 088Bh, 088Eh
                              dw                            0891h, 0894h, 0897h, 089Ah, 089Dh, 08A0h, 08A3h, 08A6h
                              dw                            08A9h, 08ACh, 08AFh, 08B2h, 08B5h, 091Eh, 0920h, 0922h
                              dw                            0963h, 0A2Ah, 0A32h, 0A42h, 0A4Eh, 0AB8h, 0ACBh, 0AEAh
                              dw                            0AF5h, 0AFEh, 0B06h, 0B61h, 0BE1h, 0BF2h, 0C0Bh, 0C10h
                              dw                            0C1Bh, 0C21h, 0C2Fh, 0C57h, 0C82h, 0C9Ah, 0CE5h, 0CFCh
                              dw                            0D05h, 0E4Ah, 0E61h, 0E6Ah, 0F04h, 0F14h, 0F33h, 0F38h
                              dw                            0F46h, 0F4Ch, 0F5Dh, 0F88h, 0FB9h, 0FD4h, 1022h, 1039h
                              dw                            1042h, 1185h, 119Ch, 11A5h, 1254h, 1265h, 126Fh, 127Fh
                              dw                            128Dh, 1298h, 12B0h, 12C2h, 12CDh, 12E0h, 12FBh, 1305h
                              dw                            1310h, 1321h, 132Ah, 1337h, 1345h, 134Eh, 1360h, 137Ch
                              dw                            1385h, 13C3h, 13FFh, 1408h, 1418h, 1421h, 142Eh, 1437h
                              dw                            1479h, 14B1h, 14C4h, 14CDh, 14DBh, 14E9h, 14F2h, 1501h
                              dw                            1540h, 1553h, 155Ch, 156Ah, 1578h, 1581h, 15D7h, 15E0h
                              dw                            16ABh, 16BCh, 16C6h, 16D6h, 16E4h, 16EFh, 1707h, 1719h
                              dw                            1724h, 1737h, 1758h, 175Ch, 1775h, 1778h, 177Eh, 1793h
                              dw                            17ABh, 17AFh, 17C8h, 17CBh, 17D1h, 17F4h, 17F8h, 1802h
                              dw                            1814h, 1817h, 1819h, 183Ah, 1856h, 185Fh, 189Ch, 18DFh
                              dw                            18E3h, 18FCh, 18FFh, 1905h, 1925h, 1929h, 1942h, 1945h
                              dw                            194Bh, 1961h, 196Ah, 19ACh, 19E4h, 19FEh, 1A02h, 1A1Bh
                              dw                            1A1Eh, 1A24h, 1A48h, 1A4Ch, 1A56h, 1A68h, 1A6Bh, 1A6Dh
                              dw                            1A8Bh, 1AC8h, 1ADBh, 1AE4h, 1AF2h, 1B00h, 1B09h, 1B64h
                              dw                            1B68h, 1B81h, 1B84h, 1B8Ah
                              dw                            16D2h-1821h
                              dw                            00F6h, 013Dh, 0148h, 0166h
                              dw                            0

u72_game_patch                dw                            403Ah
                              dw                            09C5h-403Ah
                              dw                            0033h, 003Fh, 0072h, 007Eh, 00B1h, 00B5h, 00E8h, 0120h
                              dw                            0123h, 016Fh, 0172h
                              dw                            1D63h-403Ah
                              dw                            0023h, 0028h, 0052h, 0057h, 0099h, 009Eh, 00CEh, 0102h
                              dw                            0107h, 0119h, 011Eh, 0162h, 017Ch, 0187h, 019Eh, 01B2h
                              dw                            01C2h, 01D3h, 01DEh, 020Dh, 021Fh, 0270h, 027Ah, 0284h
                              dw                            0317h, 031Fh, 0327h, 03AAh, 03B6h, 03C2h, 03F9h, 0400h
                              dw                            0435h, 043Ch, 0470h, 0477h, 0488h, 04D6h, 0517h, 051Fh
                              dw                            0522h, 0543h, 055Ch, 0561h, 056Ch, 05DEh, 05E1h, 05E7h
                              dw                            05EAh, 05F0h, 05F3h, 05F9h, 05FCh, 0602h, 0605h, 060Bh
                              dw                            060Eh, 0614h, 0617h, 061Dh, 0620h, 0699h, 06A8h, 06B3h
                              dw                            0701h, 073Ah, 07B4h, 07BAh, 07BEh, 07C8h, 07CCh, 07D9h
                              dw                            07DFh, 07E2h, 07EBh, 07EEh, 07FBh, 07FEh, 0802h, 0806h
                              dw                            0809h, 080Fh, 0817h, 082Ch, 0849h, 08BAh, 093Fh, 0941h
                              dw                            09BAh, 09BCh, 09F0h, 0A20h, 0A4Bh, 0A75h, 0A9Fh, 0AC9h
                              dw                            0B0Ah, 0B56h, 0B5Eh, 0B9Bh, 0BA3h, 0C00h, 0C0Ah, 0C5Eh
                              dw                            0C68h, 0D27h, 0D39h, 0D4Eh, 0D58h, 0D63h, 0DB8h, 0DC2h
                              dw                            0E18h, 0E22h, 0E6Ch, 0EB0h, 0EF6h, 0F34h, 0F37h, 0F3Ah
                              dw                            0F3Dh, 0F40h, 0F43h, 0F46h, 0F49h, 0F4Ch, 0F4Fh, 0F52h
                              dw                            0F55h, 0F58h, 0F5Bh, 0F5Eh, 0F61h, 0F64h, 0F67h, 0F6Ah
                              dw                            0F6Dh, 0F70h, 0F73h, 0F76h, 0F79h, 0F7Ch, 0F7Fh, 0F82h
                              dw                            0F85h, 0F88h, 0F8Bh, 0F8Eh, 0F91h, 0F94h, 0F97h, 0F9Ah
                              dw                            0F9Dh, 0FA0h, 0FA3h, 0FA6h, 0FA9h, 0FACh, 0FAFh, 0FB2h
                              dw                            0FB5h, 0FB8h, 0FBBh, 0FBEh, 0FC1h, 0FC4h, 0FC7h, 0FCAh
                              dw                            0FCDh, 0FD0h, 0FD3h, 0FD6h, 0FD9h, 0FDCh, 0FDFh, 0FE2h
                              dw                            0FE5h, 0FE8h, 0FEBh, 0FEEh, 0FF1h, 0FF4h, 0FF7h, 0FFAh
                              dw                            0FFDh, 1000h, 1003h, 1006h, 1009h, 100Ch, 100Fh, 1012h
                              dw                            1015h, 1018h, 101Bh, 101Eh, 1021h, 108Ah, 108Ch, 108Eh
                              dw                            10CFh, 1196h, 119Eh, 11AEh, 11BAh, 1223h, 1230h, 12B8h
                              dw                            12CBh, 12EAh, 12F5h, 12FEh, 1306h, 1361h, 13E1h, 13F2h
                              dw                            140Bh, 1410h, 141Bh, 1421h, 142Fh, 1457h, 1482h, 149Ah
                              dw                            14E5h, 14FCh, 1505h, 164Ah, 1661h, 166Ah, 1704h, 1714h
                              dw                            1733h, 1738h, 1746h, 174Ch, 175Dh, 1788h, 17B9h, 17D4h
                              dw                            1822h, 1839h, 1842h, 1985h, 199Ch, 19A5h, 1A3Ah, 1A4Ch
                              dw                            1A61h, 1A6Bh, 1A76h, 1B0Ch, 1B1Dh, 1B27h, 1B37h, 1B45h
                              dw                            1B50h, 1B68h, 1B7Ah, 1B85h, 1B98h, 1BB3h, 1BBDh, 1BC8h
                              dw                            1BD9h, 1BE2h, 1BEFh, 1BFDh, 1C06h, 1C18h, 1C34h, 1C3Dh
                              dw                            1C7Bh, 1CB7h, 1CC0h, 1CD0h, 1CD9h, 1CE6h, 1CEFh, 1D31h
                              dw                            1D69h, 1D7Ch, 1D85h, 1D93h, 1DA1h, 1DAAh, 1DB9h, 1DF8h
                              dw                            1E0Bh, 1E14h, 1E22h, 1E30h, 1E39h, 1E8Fh, 1E98h, 1F3Ch
                              dw                            1F4Dh, 1F57h, 1F68h, 1F76h, 1F81h, 1F9Bh, 1FACh, 1FBFh
                              dw                            1FC9h, 1FDFh, 1FF2h, 1FFFh, 2017h, 2019h, 2033h, 204Fh
                              dw                            2058h, 20AAh, 20F1h, 210Ah, 211Fh, 2128h, 217Eh, 21CDh
                              dw                            21DAh, 21F0h, 21F2h, 2208h, 2246h, 2259h, 2262h, 2270h
                              dw                            227Eh, 2287h, 22E2h, 2397h, 23A8h, 23B2h, 23C3h, 23D1h
                              dw                            23DCh, 23F6h, 2407h, 241Dh, 2427h, 244Ah, 244Dh, 244Fh
                              dw                            2466h, 2480h, 2483h, 2485h, 24AEh, 24B1h, 24B3h, 24D1h
                              dw                            24EDh, 24F6h, 254Ah, 25D1h, 25D4h, 25D6h, 25FFh, 2602h
                              dw                            2604h, 261Ch, 2625h, 267Ch, 26C7h, 26E1h, 26E4h, 26E6h
                              dw                            270Dh, 2710h, 2712h, 272Ch, 276Ch, 277Fh, 2788h, 2796h
                              dw                            27A4h, 27ADh, 2835h, 2838h, 283Ah, 290Ch, 291Dh, 2927h
                              dw                            2938h, 2946h, 2951h, 296Bh, 297Ch, 2992h, 299Ch, 29BFh
                              dw                            29C3h, 29DCh, 29DFh, 29E5h, 2A02h, 2A1Ch, 2A20h, 2A39h
                              dw                            2A3Ch, 2A42h, 2A6Eh, 2A72h, 2A7Ch, 2A96h, 2A99h, 2A9Bh
                              dw                            2AC4h, 2AE0h, 2AE9h, 2B3Dh, 2BC4h, 2BC8h, 2BE1h, 2BE4h
                              dw                            2BEAh, 2C18h, 2C1Ch, 2C35h, 2C38h, 2C3Eh, 2C5Bh, 2C64h
                              dw                            2CBCh, 2D07h, 2D21h, 2D25h, 2D3Eh, 2D41h, 2D47h, 2D73h
                              dw                            2D77h, 2D81h, 2D9Bh, 2D9Eh, 2DA0h, 2DC5h, 2E05h, 2E18h
                              dw                            2E21h, 2E2Fh, 2E3Dh, 2E46h, 2ECEh, 2ED2h, 2EEBh, 2EEEh
                              dw                            2EF4h, 2FCFh, 2FE0h, 2FEAh, 2FFAh, 3008h, 3013h, 302Bh
                              dw                            303Dh, 3048h, 305Bh, 307Ch, 3080h, 3099h, 309Ch, 30A2h
                              dw                            30B7h, 30CFh, 30D3h, 30ECh, 30EFh, 30F5h, 3118h, 311Ch
                              dw                            3126h, 3138h, 313Bh, 313Dh, 315Eh, 317Ah, 3183h, 31C0h
                              dw                            3203h, 3207h, 3220h, 3223h, 3229h, 3249h, 324Dh, 3266h
                              dw                            3269h, 326Fh, 3285h, 328Eh, 32D0h, 3308h, 3322h, 3326h
                              dw                            333Fh, 3342h, 3348h, 336Ch, 3370h, 337Ah, 338Ch, 338Fh
                              dw                            3391h, 33AFh, 33ECh, 33FFh, 3408h, 3416h, 3424h, 342Dh
                              dw                            3488h, 348Ch, 34A5h, 34A8h, 34AEh, 3583h, 3594h, 359Eh
                              dw                            35AEh, 35BCh, 35C7h, 35DFh, 35F1h, 35FCh, 360Eh, 362Fh
                              dw                            3632h, 3634h, 3643h, 365Bh, 365Eh, 3660h, 3671h, 367Eh
                              dw                            3681h, 3683h, 3699h, 36B5h, 36BEh, 36FCh, 373Fh, 3742h
                              dw                            3744h, 375Fh, 3762h, 3764h, 3775h, 377Eh, 37C0h, 37F8h
                              dw                            3812h, 3815h, 3817h, 3829h, 3836h, 3839h, 383Bh, 384Eh
                              dw                            388Bh, 389Eh, 38A7h, 38B5h, 38C3h, 38CCh, 3927h, 392Ah
                              dw                            392Ch, 3999h, 39B2h, 39CBh, 39E4h, 3A0Ch, 3A16h, 3A50h
                              dw                            3A69h, 3A82h, 3A9Bh, 3BFFh, 3C18h, 3C35h, 3C3Fh, 3C87h
                              dw                            3D0Eh, 3D18h, 3D1Bh, 3D1Dh
                              dw                            3948h-403Ah
                              dw                            0014h, 0021h, 003Ah, 0047h, 0060h
                              dw                            394Fh-403Ah
                              dw                            0027h, 002Ch, 0031h, 0036h, 003Bh, 0043h, 0047h, 004Fh
                              dw                            005Dh, 007Bh, 0080h, 00A9h, 00B3h, 00C4h, 00D0h, 00D7h
                              dw                            00E7h, 0106h, 010Ah, 0124h, 012Eh
                              dw                            39F0h-403Ah
                              dw                            007Dh, 0083h, 009Eh, 00BFh, 00C5h
                              dw                            39FDh-403Ah
                              dw                            001Eh, 0024h, 01A0h, 01CBh, 01E5h, 0203h, 021Eh, 0224h
                              dw                            3A41h-403Ah
                              dw                            0104h, 014Bh, 0156h, 0174h
                              dw                            0

u72_end_patch                 dw                            1347h
                              dw                            121Fh-1347h
                              dw                            002Eh, 00B3h, 00B5h, 012Eh, 0130h, 0164h, 0194h, 01BFh
                              dw                            01E9h, 0213h, 023Dh, 027Eh, 02CAh, 02D2h, 030Fh, 0317h
                              dw                            0373h, 037Dh, 03CFh, 03D9h, 049Bh, 04A6h, 04FAh, 0504h
                              dw                            0558h, 0562h, 05AAh, 05ECh, 0630h, 066Ch, 066Fh, 0672h
                              dw                            0675h, 0678h, 067Bh, 067Eh, 0681h, 0684h, 0687h, 068Ah
                              dw                            068Dh, 0690h, 0693h, 0696h, 0699h, 069Ch, 069Fh, 06A2h
                              dw                            06A5h, 06A8h, 06ABh, 06AEh, 06B1h, 06B4h, 06B7h, 06BAh
                              dw                            06BDh, 06C0h, 06C3h, 06C6h, 06C9h, 06CCh, 06CFh, 06D2h
                              dw                            06D5h, 06D8h, 06DBh, 06DEh, 06E1h, 06E4h, 06E7h, 06EAh
                              dw                            06EDh, 06F0h, 06F3h, 06F6h, 06F9h, 06FCh, 06FFh, 0702h
                              dw                            0705h, 0708h, 070Bh, 070Eh, 0711h, 0714h, 0717h, 071Ah
                              dw                            071Dh, 0720h, 0723h, 0726h, 0729h, 072Ch, 072Fh, 0732h
                              dw                            0735h, 0738h, 073Bh, 073Eh, 0741h, 0744h, 0747h, 074Ah
                              dw                            074Dh, 0750h, 0753h, 0756h, 0759h, 07C0h, 07C2h, 07C4h
                              dw                            0803h
                              dw                            12E1h-1347h
                              dw                            00FEh, 0142h, 014Dh, 016Bh
                              dw                            0

VXD_LOCKED_DATA_ENDS

;====================================================================================================================================================;
;                             D E V I C E                    D E C L A R A T I O N
;====================================================================================================================================================;

VXD_LOCKED_CODE_SEG

;====================================================================================================================================================;
;
; The DDB Building Macro :    Name                          U7VXD
;                             Major_Ver                     U7VXD_MAJOR_VERSION
;                             Minor_Ver                     U7VXD_MINOR_VERSION
;                             Ctrl_Proc                     U7VXD_SYSCONTROL
;                             Device_Num                    UNDEFINED_DEVICE_ID [0000]
;                             Init_Order                    UNDEFINED_INIT_ORDER [80000000]
;                             V86_Proc                      0, requires a Device_Num if present
;                             PM_Proc                       0, requires a Device_Num if present
;                             Reference_Data                0
;
;====================================================================================================================================================;

DECLARE_VIRTUAL_DEVICE        U7VXD,\
                              U7VXD_MAJOR_VERSION,\
                              U7VXD_MINOR_VERSION,\
                              U7VXD_SYSCONTROL,\
                              0,\
                              UNDEFINED_INIT_ORDER,\
                              U7VXD_V86API,\
                              ,\


;====================================================================================================================================================;
;                             M A I N                       C O D E
;====================================================================================================================================================;

;====================================================================================================================================================;
;
; U7VXD_Control - Device control procedure for the VxD. Dispatches all Windows VxD messages
;
; Exit: If carry clear        then   Successful
;                             else   Control call failed
;
; Destroys: EAX, EBX, ECX, EDX, ESI, EDI, Flags
;
;====================================================================================================================================================;

                              public                        U7VXD_SYSCONTROL
U7VXD_SYSCONTROL              PROC                          NEAR

                              Control_Dispatch              SYS_DYNAMIC_DEVICE_INIT,      U7VXD_Device_Init
                              Control_Dispatch              SYS_DYNAMIC_DEVICE_EXIT,      U7VXD_Device_Exit
                              clc
                              ret

U7VXD_SYSCONTROL              ENDP

;====================================================================================================================================================;
;
; U7VXD_Device_Exit - U7VXD Termination
;
;====================================================================================================================================================;

                              Public                        U7VXD_Device_Exit
BeginProc                     U7VXD_Device_Exit

IFDEF TRACE
                              call                          VMMMachineDump
ENDIF
IFDEF TEST_CATCHFAULT
                              mov                           esi, OFFSET32 U7VXD_PageFault_Hook
                              VMMCall                       Unhook_Invalid_Page_Fault
ENDIF
                              mov                           esi, OFFSET32 U7VXD_Break_Hook
                              mov                           eax, 3
                              VMMCall                       Unhook_V86_Int_Chain
IFDEF TEST_NONNULLDS
                              push                          0
                              movzx                         eax, VXD_GS_PM
                              push                          eax
                              push                          ebx
                              VMMCall                       _Free_LDT_Selector
                              add                           esp, 0Ch
ENDIF
IFDEF TRACE
                              call                          VMMMachineDump
ENDIF
                              clc
                              ret

EndProc                       U7VXD_Device_Exit

;====================================================================================================================================================;
;
; U7VXD_Break_Hook - Int 3 Hook in V86 / PM Mode
; The Hook is Entered with    EBX on the VMHandle
;                             EDI on the ThreadHandle
;                             ESI with 4 * Fault#
;                             EBP on a Client Area
;
;====================================================================================================================================================;

                              Public                        U7VXD_Break_Hook
BeginProc                     U7VXD_Break_Hook

                              cmp                           ebx, VXD_VMHandle
                              je                            U7VXD_Break_Hook_Valid

                              stc
                              ret
U7VXD_Break_Hook_Valid:
IFDEF TEST_FIXSISHAPE
                              cmp                           VXD_CurrentProgram, VXD_IsSIGame
                              jne                           U7VXD_Break_Hook_Normal
                              push                          eax
                              movzx                         eax, word ptr [ebp].Client_EIP
                              cmp                           eax, 12b9h
                              jne                           U7VXD_Break_Hook_Proceed
                              test                     byte ptr [ebp].Client_ESI+3, 080h
                              jz                            U7VXD_Break_Hook_Proceed
                              test                     byte ptr [ebp].Client_EBX+3, 0ffh
                              jnz                           U7VXD_Break_Hook_Bug
                              mov                           eax, [ebp].Client_ESI
                              add                           eax, [ebp].Client_EBX
                              test                     byte ptr [eax+07h], 0ffh
                              jz                            U7VXD_Break_Hook_Proceed
U7VXD_Break_Hook_Bug:
IFDEF TRACE
                              call                          VMMMachineDump
                              call                          V86MachineDump
                              call                          V86StackScan
                              mov                           esi, [ebp].Client_ESI
                              mov                           ecx, 0100h
                              call                          VMMStorageDump
ENDIF
                              mov                           ax, 12c0h
                              mov                      word ptr [ebp].Client_EIP, ax
                              pop                           eax
                              clc
                              ret
U7VXD_Break_Hook_Proceed:
                              pop                           eax
U7VXD_Break_Hook_Normal:
ENDIF
                              call                          callback_proc
                              clc
                              ret

EndProc                       U7VXD_Break_Hook

IFDEF TEST_CATCHFAULT
;====================================================================================================================================================;
;
; U7VXD_PageFault_Hook - Debugging Help
; The Hook is Entered with    EBX on the VMHandle
;                             EDI IPF Block               
;                             EBP on a Client Area
;
;====================================================================================================================================================;
                              Public                        U7VXD_PageFault_Hook
BeginProc                     U7VXD_PageFault_Hook

                              cmp                           ebx, VXD_VMHandle
                              je                            U7VXD_PageFault_Hook_Valid

                              stc
                              ret
U7VXD_PageFault_Hook_Valid:
                              call                          VMMMachineDump
                              push                          ebp
                              mov                           ebp, [ebx].CB_Client_Pointer
                              call                          V86MachineDump
                              call                          V86StackScan
                              push                          esi
                              push                          ecx
                              movzx                         esi, word ptr [ebp].Client_SS
                              shl                           esi, 4
                              mov                           ecx, 00010000h
                              call                          VMMStorageDump
                              mov                           esi, VXD_BlockAddress
                              mov                           ecx, VXD_BlockSize
                              call                          VMMStorageDump
                              pop                           ecx
                              pop                           esi
                              pop                           ebp

                              stc
                              ret

EndProc                       U7VXD_PageFault_Hook
ENDIF
;====================================================================================================================================================;
;
; U7VXD_V86API - U7VXD V86 Interface
;
;====================================================================================================================================================;

                              Public                        U7VXD_V86API
BeginProc                     U7VXD_V86API

IFDEF TRACE
                              call                          VMMMachineDump
ENDIF
                              clc
                              ret

EndProc                       U7VXD_V86API

;====================================================================================================================================================;
;
; The Heart of U7VXD, the VOODOO instruction interpreter
;
;====================================================================================================================================================;

LoadClientFlags               MACRO
                              push                          eax
                              push                          ebx
                              pushfd
                              pop                           eax
                              and                           eax, 0fffff300h
                              mov                           ebx, [ebp].Client_EFlags
                              and                           ebx, 000000cffh
                              or                            eax, ebx
                              push                          eax
                              popfd
                              pop                           ebx
                              pop                           eax
                              ENDM

SaveClientFlags               MACRO
                              push                          eax
                              push                          ebx
                              pushfd
                              pop                           eax
                              and                           eax, 000000cffh
                              mov                           ebx, [ebp].Client_EFlags
                              and                           ebx, 0fffff300h
                              or                            eax, ebx
                              mov                           [ebp].Client_EFlags, eax
                              pop                           ebx
                              pop                           eax
                              ENDM

BeginProc                     callback_proc

                              movzx                         esi, word ptr [ebp].Client_EIP
                              movzx                         eax, word ptr [ebp].Client_CS
                              shl                           eax, 4
                              add                           esi, eax
                              lods                     byte ptr ds:[esi]
                              inc                           word ptr [ebp].Client_EIP
                              mov                           ah, al
                              or                            ah, ah
                              je                            callback_load_machine
callback_build_format:
                              mov                           edi, OFFSET32 callback_type_run
callback_build_format_0:
                              cmp                           ah, 040h
                              jae                           callback_build_format_1
                              test                          ah, 01h
                              jnz                           callback_build_format_0_1
                              mov                           al, 066h
                              stos                     byte ptr es:[edi]
                              dec                           word ptr [ebp].Client_EIP
                              dec                           esi
callback_build_format_0_1:
IFDEF TEST_NONNULLDS

                              mov                           al, 065h                    
                              stos                     byte ptr es:[edi]
ENDIF
                              mov                           cx, word ptr [ebp].Client_DS
                              test                          ah, 02h
                              jz                            callback_build_format_0_2
IFDEF TEST_NONNULLDS
                              mov                           cx, word ptr [ebp].Client_ES
ENDIF
                              inc                           word ptr [ebp].Client_EIP
                              inc                           esi
callback_build_format_0_2:
IFDEF TEST_NONNULLDS
                              mov                           VXD_GS_V86, cx
ENDIF
                              movzx                         ecx, ah
                              shr                           ecx, 02h
                              inc                           ecx
callback_build_format_bytes:
                              inc                           ecx
callback_build_format_move:
                              lods                     byte ptr ds:[esi]
                              inc                           word ptr [ebp].Client_EIP
                              stos                     byte ptr es:[edi]
                              loop                          callback_build_format_move
callback_build_format_finish:
                              mov                           al, 0c3h
                              stos                     byte ptr es:[edi]
                              jmp                           callback_load_machine
callback_build_format_1:
                              cmp                           ah, 080h
                              jae                           callback_build_format_2
                              movzx                         edx, ah
                              jmp                     dword ptr cs:[callback_vector-0100h+edx*4]
callback_vector:
                              dd                            OFFSET32 callback_fast_0040
                              dd                            01h dup(OFFSET32 callback_unexpected)
                              dd                            OFFSET32 callback_fast_0042
                              dd                            01h dup(OFFSET32 callback_unexpected)
                              dd                            OFFSET32 callback_fast_0044
                              dd                            OFFSET32 callback_fast_0045
                              dd                            OFFSET32 callback_fast_0046
                              dd                            OFFSET32 callback_fast_0047
                              dd                            08h dup(OFFSET32 callback_unexpected)
                              dd                            OFFSET32 callback_fast_0050
                              dd                            01h dup(OFFSET32 callback_unexpected)
                              dd                            OFFSET32 callback_fast_0052
                              dd                            01h dup(OFFSET32 callback_unexpected)
                              dd                            OFFSET32 callback_fast_0054
                              dd                            OFFSET32 callback_fast_0055
                              dd                            OFFSET32 callback_fast_0056
                              dd                            OFFSET32 callback_fast_0057
                              dd                            OFFSET32 callback_fast_0058
                              dd                            03h dup(OFFSET32 callback_unexpected)
                              dd                            OFFSET32 callback_fast_005C
                              dd                            OFFSET32 callback_fast_005D
                              dd                            02h dup(OFFSET32 callback_unexpected)
                              dd                            08h dup(OFFSET32 callback_unexpected)
                              dd                            OFFSET32 callback_fast_0068
                              dd                            07h dup(OFFSET32 callback_unexpected)
                              dd                            10h dup(OFFSET32 callback_unexpected)
callback_fast_0040:
                              movzx                         eax, [ebp].Client_DS
                              movzx                         edx, [ebp].Client_ES
                              shl                           eax, 4
                              shl                           edx, 4
                              mov                           esi, [ebp].Client_ESI
                              mov                           edi, [ebp].Client_EDI
                              add                           esi, eax
                              add                           edi, edx
IFDEF TEST_SETUPFLAGS
                              LoadClientFlags
ENDIF
                              movs                     byte ptr es:[edi], byte ptr ds:[esi]
IFDEF TEST_SETUPFLAGS
                              SaveClientFlags
ENDIF
                              sub                           esi, eax
                              sub                           edi, edx
                              mov                           [ebp].Client_ESI, esi
                              mov                           [ebp].Client_EDI, edi
                              ret
callback_fast_0042:
                              movzx                         eax, [ebp].Client_DS
                              movzx                         edx, [ebp].Client_ES
                              shl                           eax, 4
                              shl                           edx, 4
                              mov                           esi, [ebp].Client_ESI
                              mov                           edi, [ebp].Client_EDI
                              mov                           ecx, [ebp].Client_ECX
                              add                           esi, eax
                              add                           edi, edx
IFDEF TEST_SETUPFLAGS
                              LoadClientFlags
ENDIF
                          rep movs                     byte ptr es:[edi], byte ptr ds:[esi]
IFDEF TEST_SETUPFLAGS
                              SaveClientFlags
ENDIF
                              sub                           esi, eax
                              sub                           edi, edx
                              mov                           [ebp].Client_ESI, esi
                              mov                           [ebp].Client_EDI, edi
                              mov                           [ebp].Client_ECX, ecx
                              inc                           word ptr [ebp].Client_EIP
                              ret
callback_fast_0044:
                              movzx                         eax, [ebp].Client_DS
                              movzx                         edx, [ebp].Client_ES
                              shl                           eax, 4
                              shl                           edx, 4
                              mov                           esi, [ebp].Client_ESI
                              mov                           edi, [ebp].Client_EDI
                              add                           esi, eax
                              add                           edi, edx
IFDEF TEST_SETUPFLAGS
                              LoadClientFlags
ENDIF
                              movs                     word ptr es:[edi], word ptr ds:[esi]
IFDEF TEST_SETUPFLAGS
                              SaveClientFlags
ENDIF
                              sub                           esi, eax
                              sub                           edi, edx
                              mov                           [ebp].Client_ESI, esi
                              mov                           [ebp].Client_EDI, edi
                              ret
callback_fast_0045:
                              movzx                         eax, [ebp].Client_DS
                              movzx                         edx, [ebp].Client_ES
                              shl                           eax, 4
                              shl                           edx, 4
                              mov                           esi, [ebp].Client_ESI
                              mov                           edi, [ebp].Client_EDI
                              add                           esi, eax
                              add                           edi, edx
IFDEF TEST_SETUPFLAGS
                              LoadClientFlags
ENDIF
                              movs                    dword ptr es:[edi], dword ptr ds:[esi]
IFDEF TEST_SETUPFLAGS
                              SaveClientFlags
ENDIF
                              sub                           esi, eax
                              sub                           edi, edx
                              mov                           [ebp].Client_ESI, esi
                              mov                           [ebp].Client_EDI, edi
                              inc                           word ptr [ebp].Client_EIP
                              ret
callback_fast_0046:
                              movzx                         eax, [ebp].Client_DS
                              movzx                         edx, [ebp].Client_ES
                              shl                           eax, 4
                              shl                           edx, 4
                              mov                           esi, [ebp].Client_ESI
                              mov                           edi, [ebp].Client_EDI
                              mov                           ecx, [ebp].Client_ECX
                              add                           esi, eax
                              add                           edi, edx
IFDEF TEST_SETUPFLAGS
                              LoadClientFlags
ENDIF
                          rep movs                     word ptr es:[edi], word ptr ds:[esi]
IFDEF TEST_SETUPFLAGS
                              SaveClientFlags
ENDIF
                              sub                           esi, eax
                              sub                           edi, edx
                              mov                           [ebp].Client_ESI, esi
                              mov                           [ebp].Client_EDI, edi
                              mov                           [ebp].Client_ECX, ecx
                              inc                           word ptr [ebp].Client_EIP
                              ret
callback_fast_0047:
                              movzx                         eax, [ebp].Client_DS
                              movzx                         edx, [ebp].Client_ES
                              shl                           eax, 4
                              shl                           edx, 4
                              mov                           esi, [ebp].Client_ESI
                              mov                           edi, [ebp].Client_EDI
                              mov                           ecx, [ebp].Client_ECX
                              add                           esi, eax
                              add                           edi, edx
IFDEF TEST_SETUPFLAGS
                              LoadClientFlags
ENDIF
                          rep movs                    dword ptr es:[edi], dword ptr ds:[esi]
IFDEF TEST_SETUPFLAGS
                              SaveClientFlags
ENDIF
                              sub                           esi, eax
                              sub                           edi, edx
                              mov                           [ebp].Client_ESI, esi
                              mov                           [ebp].Client_EDI, edi
                              mov                           [ebp].Client_ECX, ecx
                              inc                           word ptr [ebp].Client_EIP
                              inc                           word ptr [ebp].Client_EIP
                              ret
callback_fast_0050:
                              movzx                         edx, [ebp].Client_ES
                              shl                           edx, 4
                              mov                           edi, [ebp].Client_EDI
                              mov                           al, byte ptr [ebp].Client_EAX
                              add                           edi, edx
IFDEF TEST_SETUPFLAGS
                              LoadClientFlags
ENDIF
                              stos                     byte ptr es:[edi]
IFDEF TEST_SETUPFLAGS
                              SaveClientFlags
ENDIF
                              sub                           edi, edx
                              mov                           [ebp].Client_EDI, edi
                              ret
callback_fast_0052:
                              movzx                         edx, [ebp].Client_ES
                              shl                           edx, 4
                              mov                           edi, [ebp].Client_EDI
                              mov                           al, byte ptr [ebp].Client_EAX
                              mov                           ecx, [ebp].Client_ECX
                              add                           edi, edx
IFDEF TEST_SETUPFLAGS
                              LoadClientFlags
ENDIF
                          rep stos                     byte ptr es:[edi]
IFDEF TEST_SETUPFLAGS
                              SaveClientFlags
ENDIF
                              sub                           edi, edx
                              mov                           [ebp].Client_EDI, edi
                              mov                           [ebp].Client_ECX, ecx
                              inc                           word ptr [ebp].Client_EIP
                              ret
callback_fast_0054:
                              movzx                         edx, [ebp].Client_ES
                              shl                           edx, 4
                              mov                           edi, [ebp].Client_EDI
                              mov                           ax, word ptr [ebp].Client_EAX
                              add                           edi, edx
IFDEF TEST_SETUPFLAGS
                              LoadClientFlags
ENDIF
                              stos                     word ptr es:[edi]
IFDEF TEST_SETUPFLAGS
                              SaveClientFlags
ENDIF
                              sub                           edi, edx
                              mov                           [ebp].Client_EDI, edi
                              ret
callback_fast_0055:
                              movzx                         edx, [ebp].Client_ES
                              shl                           edx, 4
                              mov                           edi, [ebp].Client_EDI
                              mov                           eax, [ebp].Client_EAX
                              add                           edi, edx
IFDEF TEST_SETUPFLAGS
                              LoadClientFlags
ENDIF
                              stos                    dword ptr es:[edi]
IFDEF TEST_SETUPFLAGS
                              SaveClientFlags
ENDIF
                              sub                           edi, edx
                              mov                           [ebp].Client_EDI, edi
                              inc                           word ptr [ebp].Client_EIP
                              ret
callback_fast_0056:
                              movzx                         edx, [ebp].Client_ES
                              shl                           edx, 4
                              mov                           edi, [ebp].Client_EDI
                              mov                           ax, word ptr [ebp].Client_EAX
                              mov                           ecx, [ebp].Client_ECX
                              add                           edi, edx
IFDEF TEST_SETUPFLAGS
                              LoadClientFlags
ENDIF
                          rep stos                     word ptr es:[edi]
IFDEF TEST_SETUPFLAGS
                              SaveClientFlags
ENDIF
                              sub                           edi, edx
                              mov                           [ebp].Client_EDI, edi
                              mov                           [ebp].Client_ECX, ecx
                              inc                           word ptr [ebp].Client_EIP
                              ret
callback_fast_0057:
                              movzx                         edx, [ebp].Client_ES
                              shl                           edx, 4
                              mov                           edi, [ebp].Client_EDI
                              mov                           eax, [ebp].Client_EAX
                              mov                           ecx, [ebp].Client_ECX
                              add                           edi, edx
IFDEF TEST_SETUPFLAGS
                              LoadClientFlags
ENDIF
                          rep stos                    dword ptr es:[edi]
IFDEF TEST_SETUPFLAGS
                              SaveClientFlags
ENDIF
                              sub                           edi, edx
                              mov                           [ebp].Client_EDI, edi
                              mov                           [ebp].Client_ECX, ecx
                              inc                           word ptr [ebp].Client_EIP
                              inc                           word ptr [ebp].Client_EIP
                              ret
callback_fast_0058:
                              movzx                         edx, [ebp].Client_DS
                              shl                           edx, 4
                              mov                           esi, [ebp].Client_ESI
                              add                           esi, edx
IFDEF TEST_SETUPFLAGS
                              LoadClientFlags
ENDIF
                              lods                     byte ptr ds:[esi]
IFDEF TEST_SETUPFLAGS
                              SaveClientFlags
ENDIF
                              sub                           esi, edx
                              mov                      byte ptr [ebp].Client_EAX, al
                              mov                           [ebp].Client_ESI, esi
                              ret
callback_fast_005C:
                              movzx                         edx, [ebp].Client_DS
                              shl                           edx, 4
                              mov                           esi, [ebp].Client_ESI
                              add                           esi, edx
IFDEF TEST_SETUPFLAGS
                              LoadClientFlags
ENDIF
                              lods                     word ptr ds:[esi]
IFDEF TEST_SETUPFLAGS
                              SaveClientFlags
ENDIF
                              sub                           esi, edx
                              mov                      word ptr [ebp].Client_EAX, ax
                              mov                           [ebp].Client_ESI, esi
                              ret
callback_fast_005D:
                              movzx                         edx, [ebp].Client_DS
                              shl                           edx, 4
                              mov                           esi, [ebp].Client_ESI
                              add                           esi, edx
IFDEF TEST_SETUPFLAGS
                              LoadClientFlags
ENDIF
                              lods                    dword ptr ds:[esi]
IFDEF TEST_SETUPFLAGS
                              SaveClientFlags
ENDIF
                              sub                           esi, edx
                              mov                           [ebp].Client_EAX, eax
                              mov                           [ebp].Client_ESI, esi
                              inc                           word ptr [ebp].Client_EIP
                              ret
callback_fast_0068:
                              movzx                         ebx, [ebp].Client_DS
                              shl                           ebx, 4
                              add                           ebx, [ebp].Client_EBX
                              mov                           al, byte ptr [ebp].Client_EAX
IFDEF TEST_SETUPFLAGS
                              LoadClientFlags
ENDIF
                              xlat                     byte ptr ds:[ebx]
IFDEF TEST_SETUPFLAGS
                              SaveClientFlags
ENDIF
                              mov                      byte ptr [ebp].Client_EAX, al
                              ret
callback_build_format_2:
                              mov                           al, 066h
                              stos                     byte ptr es:[edi]
IFDEF TEST_NONNULLDS
                              mov                           al, 065h
                              stos                     byte ptr es:[edi]
                              mov                           cx, word ptr [ebp].Client_DS
                              mov                           VXD_GS_V86, cx
ENDIF
                              movzx                         ecx, ah
                              and                           ah, 0e3h
                              mov                           al, 088h
                              cmp                           ah, 080h
                              je                            callback_build_format_2_finish
                              mov                           al, 089h
                              cmp                           ah, 081h
                              je                            callback_build_format_2_finish
                              mov                           al, 08ah
                              cmp                           ah, 082h
                              je                            callback_build_format_2_finish
                              mov                           al, 08bh
                              cmp                           ah, 083h
                              je                            callback_build_format_2_finish
                              mov                           al, 003h
                              cmp                           ah, 0a0h
                              je                            callback_build_format_2_finish
                              mov                           al, 013h
                              cmp                           ah, 0a1h
                              je                            callback_build_format_2_finish
                              mov                           al, 02bh
                              cmp                           ah, 0a2h
                              je                            callback_build_format_2_finish
                              mov                           al, 00bh
                              cmp                           ah, 0a3h
                              je                            callback_build_format_2_finish
                              mov                           al, 0c7h
                              cmp                           ah, 0c0h
                              je                            callback_build_format_2_finish
                              mov                           al, 0f7h
                              cmp                           ah, 0c1h
                              je                            callback_build_format_2_finish
                              mov                           al, 038h
                              cmp                           ah, 0e0h
                              je                            callback_build_format_2_finish
                              mov                           al, 039h
                              cmp                           ah, 0e1h
                              je                            callback_build_format_2_finish
                              mov                           al, 03ah
                              cmp                           ah, 0e2h
                              je                            callback_build_format_2_finish
                              mov                           al, 03bh
                              cmp                           ah, 0e3h
                              je                            callback_build_format_2_finish
                              jmp                           callback_unexpected
callback_build_format_2_finish:
                              stos                     byte ptr es:[edi]
                              and                           cl, 1ch
                              shr                           ecx, 02h
                              jmp                           callback_build_format_bytes
callback_load_machine:
                              cmp                           ah, 00h
                              jne                           callback_type_other
callback_type_trace:
                              mov                           eax, [ebp].Client_EAX
                              cmp                           ax, 0301h
                              jne                           callback_type_patch
IFDEF TRACE
                              call                          V86MachineDump
                              shr                           eax, 16
                              cmp                           ah, 3dh
                              je                            callback_type_trace_data
                              call                          V86StackScan
                              ret
callback_type_trace_data:
                              movzx                         esi, word ptr [ebp].Client_DS
                              shl                           esi, 4
                              movzx                         ecx, word ptr [ebp].Client_EDX
                              add                           esi, ecx
                              mov                           ecx, 00000040h
                              call                          VMMStorageDump
                              call                          V86StackScan
ENDIF
                              ret
callback_type_patch:
                              mov                           eax, [ebp].Client_EAX
                              cmp                           ax, 0401h
                              jne                           callback_dpmi_get
                              mov                           ebx, [ebp].Client_EBX
                              mov                           VXD_CurrentProgram, bl
callback_patch_main_u71:
                              cmp                           bx, VXD_IsBGMain
                              jne                           callback_patch_game_u71
                              mov                           ebx, OFFSET32 u71_main_patch
                              jmp                           callback_patch_start
callback_patch_game_u71:
                              cmp                           bx, VXD_IsBGGame
                              jne                           callback_patch_end_u71
                              mov                           ebx, OFFSET32 u71_game_patch
                              jmp                           callback_patch_start
callback_patch_end_u71:
                              cmp                           bx, VXD_IsBGEndGame
                              jne                           callback_patch_int_u72
                              mov                           ebx, OFFSET32 u71_end_patch
                              jmp                           callback_patch_start
callback_patch_int_u72:
                              cmp                           bx, VXD_IsSIIntro
                              jne                           callback_patch_main_u72
                              mov                           ebx, OFFSET32 u72_int_patch
                              jmp                           callback_patch_start
callback_patch_main_u72:
                              cmp                           bx, VXD_IsSIMain
                              jne                           callback_patch_game_u72
                              mov                           ebx, OFFSET32 u72_main_patch
                              jmp                           callback_patch_start
callback_patch_game_u72:
                              cmp                           bx, VXD_IsSIGame
                              jne                           callback_patch_end_u72
                              mov                           ebx, OFFSET32 u72_game_patch
                              jmp                           callback_patch_start
callback_patch_end_u72:
                              cmp                           bx, VXD_IsSIEndGame
                              jne                           callback_type_00_end
                              mov                           ebx, OFFSET32 u72_end_patch
                              jmp                           callback_patch_start
callback_patch_start:
                              mov                           esi, [ebp].Client_ECX
                              sub                           si, word ptr [ebx]
                              movzx                         edi, si
                              shl                           edi, 4
                              mov                           VXD_ProgramBase, edi
                              inc                           ebx
                              inc                           ebx
callback_patch_loop:
                              movzx                         esi, word ptr [ebx]
                              or                            si, si
                              jz                            callback_patch_end
                              js                            callback_patch_ds
                              add                           esi, eax
                              cmp                      byte ptr [esi], 0cch
                              je                            callback_type_00_end

                              call                          interrupt_insert
                              jc                            callback_type_00_error

                              inc                           ebx
                              inc                           ebx
                              jmp                           callback_patch_loop
callback_patch_ds:
                              mov                           esi, [ebp].Client_ECX
                              add                           si, word ptr [ebx]
                              movzx                         eax, si
                              shl                           eax, 4
                              inc                           ebx
                              inc                           ebx
                              jmp                           callback_patch_loop
callback_patch_end:
IFDEF TEST_FIXSIINTRO
                              cmp                           VXD_CurrentProgram, VXD_IsSIIntro
                              jne                           callback_type_00_end
                              mov                           esi, VXD_ProgramBase
                              mov                      byte ptr [esi+395bh], 0c3h
ENDIF
                              jmp                           callback_type_00_end
callback_dpmi_get:
                              mov                           eax, [ebp].Client_EAX
                              cmp                           ax, 0501h
                              jne                           callback_dpmi_free
IFDEF TRACE
                              call                          V86MachineDump
ENDIF
                              mov                           ax,  word ptr [ebp].Client_EBX
                              shl                           eax, 16
                              mov                           ax,  word ptr [ebp].Client_ECX
                              push                          eax
                              mov                           ecx, eax
                              shr                           eax, 12
                              test                          ecx, 00000fffh
                              jz                            callback_dpmi_allocate
                              inc                           eax
callback_dpmi_allocate:
                              VMMCall         _PageAllocate <eax, PG_VM, ebx, 0, 0, 0, 0, PAGEFIXED + PAGEZEROINIT>
                              jc                            callback_dpmi_get_error
                              mov                           VXD_BlockAddress, eax
                              mov                      word ptr [ebp].Client_EDI, ax
                              shr                           eax, 16
                              mov                      word ptr [ebp].Client_ESI, ax
                              pop                           eax
                              mov                           VXD_BlockSize, eax
callback_type_00_end:  
                              and                      byte ptr [ebp].Client_EFlags, 0FEh
IFDEF TRACE
                              call                          V86MachineDump
ENDIF
                              ret
callback_dpmi_get_error:
                              pop                           ecx
callback_type_00_error:
                              or                       byte ptr [ebp].Client_EFlags, 001h
IFDEF TRACE
                              call                          V86MachineDump
ENDIF
                              ret
callback_dpmi_free:
                              cmp                           ax, 0502h
                              jne                           callback_unexpected
IFDEF TRACE
                              call                          V86MachineDump
ENDIF
                              xor                           eax, eax
                              mov                           VXD_BlockSize, eax
                              mov                           VXD_BlockAddress, eax
                              mov                           ax,  word ptr [ebp].Client_ESI
                              shl                           eax, 16
                              mov                           ax,  word ptr [ebp].Client_EDI
                              VMMCall             _PageFree <eax, 0>
                              jc                            callback_type_00_error
                              and                      byte ptr [ebp].Client_EFlags, 0FEh
IFDEF TRACE
                              call                          V86MachineDump
ENDIF
                              ret
callback_type_other:
                              mov                           eax, [ebp].Client_EAX
                              mov                           ebx, [ebp].Client_EBX
                              mov                           ecx, [ebp].Client_ECX
                              mov                           edx, [ebp].Client_EDX
                              mov                           esi, [ebp].Client_ESI
                              mov                           edi, [ebp].Client_EDI
callback_type_segreg:
                              push                          eax
                              push                          ebx
                              push                          edx
IFDEF TEST_NONNULLDS
                              movzx                         ebx, word ptr VXD_GS_V86          
                              or                            ebx, ebx
                              jnz                           callback_load_segreg
                              push                          ds
                              pop                           gs
ENDIF
callback_type_flags:
                              LoadClientFlags

                              pop                           edx
                              pop                           ebx
                              pop                           eax
                              push                          OFFSET32 callback_return
                              push                          OFFSET32 callback_type_run
                              ret
IFDEF TEST_NONNULLDS
callback_load_segreg:
IFDEF TRACE
                              call                          VMMMachineDump
                              call                          V86MachineDump
                              call                          V86StackScan
ENDIF
                              shl                           ebx, 4
                              push                          0
                              mov                           ax, bx
                              shl                           eax, 16
                              or                            eax, 0000FFFFh                          ; EAX = base_1:base_0            :limit_1:limit_0
                              push                          eax
                              shr                           ebx, 16
                              mov                           dl, bh
                              shl                           edx, 24
                              mov                           dl, bl
                              or                            edx, 004F9200h                          ; EDX = base_3:attributes/limit_2:type   :base_2
                              push                          edx
                              mov                           ebx, VXD_VMHandle
                              push                          ebx
                              movzx                         ebx, VXD_GS_PM
                              push                          ebx
IFDEF TRACE
                              call                          VMMMachineDump
                              call                          V86MachineDump
                              call                          V86StackScan
ENDIF
                              VMMCall                       _SetDescriptor
                              add                           esp, 14h
IFDEF TRACE
                              call                          VMMMachineDump
                              call                          V86MachineDump
                              call                          V86StackScan
ENDIF
                              mov                           ax, VXD_GS_PM
                              mov                           gs, ax
                              jmp                           callback_type_flags
ENDIF
callback_return:
                              SaveClientFlags

                              mov                           [ebp].Client_EAX, eax
                              mov                           [ebp].Client_EBX, ebx
                              mov                           [ebp].Client_ECX, ecx
                              mov                           [ebp].Client_EDX, edx
                              mov                           [ebp].Client_ESI, esi
                              mov                           [ebp].Client_EDI, edi
callback_exit:
                              ret
callback_unexpected:
IFDEF TRACE
                              call                          VMMMachineDump
                              call                          V86MachineDump
                              call                          V86StackScan
ENDIF
                              ret

Endproc                       callback_proc

;====================================================================================================================================================;
;
; The Way U7VXD is invoked, the DOS Programs are Patched with CC xx (Int 03)
;
;
;                             Address 32 [67h] prefix is always assumed
;                             Format Special for Int 31       is  0000 0000
;                             Format 0 Code (for non strings) is  000b bbcd (with cd <> 00)
;                              where d = 1 Data    32 (66h prefix)
;                              where c = 1 ES:        (26h prefix) for not strings
;                              where b bb = 0 00 The instruction proper is 2 bytes
;                              where b bb = 0 01 The instruction proper is 3 bytes
;                              where b bb = 0 10 The instruction proper is 4 bytes
;                              where b bb = 0 11 The instruction proper is 5 bytes
;                              where b bb = 1 00 The instruction proper is 6 bytes
;                              where b bb = 1 01 The instruction proper is 7 bytes
;                              where b bb = 1 10 The instruction proper is 8 bytes
;                              where b bb = 1 11 The instruction proper is 9 bytes
;                              the codop byte is never missing (cd <> 0 implies 2+ prefix bytes)
;                             Format 1 Code (for strings)     is  01aa aacd
;                              where d = 1 Data    32 (66h prefix)
;                              where c = 1 REP        (f3h prefix) for strings
;                              the instruction proper is always 1 byte
;                              where aa aa = 00 00 a4 MovsB
;                              where aa aa = 00 01 a5 MovsW
;                              where aa aa = 00 10 a6 CmpsB
;                              where aa aa = 00 11 a7 CmpsW
;                              where aa aa = 01 00 aa StosB
;                              where aa aa = 01 01 ab StosW
;                              where aa aa = 01 10 ac LodsB
;                              where aa aa = 01 11 ad LodsW
;                              where aa aa = 10 00 ae ScasB
;                              where aa aa = 10 01 af ScasW
;                              where aa aa = 10 10 d7 Xlat
;                             Format 2 Code (for non strings) is  1aab bbaa (no other prefix than 67h, codop overwritten)
;                              where b bb = 0 00 The instruction proper is 2 bytes
;                              where b bb = 0 01 The instruction proper is 3 bytes
;                              where b bb = 0 10 The instruction proper is 4 bytes
;                              where b bb = 0 11 The instruction proper is 5 bytes
;                              where b bb = 1 00 The instruction proper is 6 bytes
;                              where b bb = 1 01 The instruction proper is 7 bytes
;                              where b bb = 1 10 The instruction proper is 8 bytes
;                              where b bb = 1 11 The instruction proper is 9 bytes
;                              where aa aa = 00 00 Codop Byte is 88 Mov  Eb,Gb (67h only prefix)
;                              where aa aa = 00 01 Codop Byte is 89 Mov  Ev,Gv (67h only prefix)
;                              where aa aa = 00 10 Codop Byte is 8a Mov  Gb,Eb (67h only prefix)
;                              where aa aa = 00 11 Codop Byte is 8b Mov  Gv,Ev (67h only prefix)
;                              where aa aa = 01 00 Codop Byte is 03 Add  Gv,Ev (67h only prefix)
;                              where aa aa = 01 01 Codop Byte is 13 Adc  Gv,Ev (67h only prefix)
;                              where aa aa = 01 10 Codop Byte is 2b Sub  Gv,Ev (67h only prefix)
;                              where aa aa = 01 11 Codop Byte is 0b Or   Gv,Ev (67h only prefix)
;                              where aa aa = 10 00 Codop Byte is c7 Mov  Gv,Iv (67h only prefix)
;                              where aa aa = 10 01 Codop Byte is f7 Test Gv,Iv (67h only prefix)
;                              where aa aa = 11 00 Codop Byte is 38 Cmp  Eb,Gb (67h only prefix)
;                              where aa aa = 11 01 Codop Byte is 39 Cmp  Ev,Gv (67h only prefix)
;                              where aa aa = 11 10 Codop Byte is 3a Cmp  Gb,Gb (67h only prefix)
;                              where aa aa = 11 11 Codop Byte is 3b Cmp  Gv,Ev (67h only prefix)
;
;====================================================================================================================================================;

BeginProc                     interrupt_insert

                              pushad
                              xor                           edx, edx
                              push                          esi
                              lods                     byte ptr ds:[esi]
interrupt_insert_rep:
                              cmp                           al, 0f3h
                              jne                           interrupt_insert_reg32
                              or                            dl, 02h
                              lods                     byte ptr ds:[esi]
interrupt_insert_reg32:
                              cmp                           al, 066h
                              jne                           interrupt_insert_es
                              or                            dl, 01h
                              lods                     byte ptr ds:[esi]
interrupt_insert_es:
                              cmp                           al, 026h
                              jne                           interrupt_insert_adr32
                              test                          dl, 02h
                              jnz                           interrupt_insert_none
                              or                            dl, 02h
                              lods                     byte ptr ds:[esi]
interrupt_insert_adr32:
                              cmp                           al, 067h
                              jne                           interrupt_insert_none
                              lods                     byte ptr ds:[esi]
interrupt_insert_string_1:
                              cmp                           al, 0a4h
                              jb                            interrupt_insert_size
                              cmp                           al, 0a7h
                              ja                            interrupt_insert_string_2
                              sub                           al, 094h
                              shl                           al, 02
                              jmp                           interrupt_insert_common

interrupt_insert_string_2:
                              cmp                           al, 0aah
                              jb                            interrupt_insert_size
                              cmp                           al, 0afh
                              ja                            interrupt_insert_string_3
                              sub                           al, 096h
                              shl                           al, 02
                              jmp                           interrupt_insert_common

interrupt_insert_string_3:
                              cmp                           al, 0d7h
                              jne                           interrupt_insert_size
                              mov                           al, 068h
                              jmp                           interrupt_insert_common
interrupt_insert_size:
                              mov                           ah, al
                              lods                     byte ptr ds:[esi]
                              mov                           bh, al
                              and                           al, 0c7h
                              cmp                           al, 0c0h
                              jae                           interrupt_insert_computed
                              cmp                           al, 004h
                              je                            interrupt_insert_extra_byte
                              cmp                           al, 044h
                              je                            interrupt_insert_extra_byte
                              cmp                           al, 084h
                              jne                           interrupt_insert_modrm
interrupt_insert_extra_byte:
                              lods                     byte ptr ds:[esi]
                              mov                           bl, al
                              and                           al, 007h
                              and                           bh, 0c0h
                              or                            al, bh
                              inc                           dh
interrupt_insert_modrm:
                              cmp                           al, 005h
                              je                            interrupt_insert_add_4
                              cmp                           al, 040h
                              jb                            interrupt_insert_computed
                              cmp                           al, 080h
                              jb                            interrupt_insert_add_1
interrupt_insert_add_4:
                              lods                     byte ptr ds:[esi]
                              inc                           dh
                              lods                     byte ptr ds:[esi]
                              inc                           dh
                              lods                     byte ptr ds:[esi]
                              inc                           dh
interrupt_insert_add_1:
                              lods                     byte ptr ds:[esi]
                              inc                           dh
interrupt_insert_computed:
                              cmp                           dh, 007h
                              ja                            interrupt_insert_none
                              or                            dl, dl
                              jz                            interrupt_insert_short
interrupt_insert_long:
                              mov                           al, dl
                              shr                           dx, 06h
                              jmp                           interrupt_insert_common
interrupt_insert_short:
                              shr                           dx, 06h
                              mov                           al, 080h
                              cmp                           ah, 088h
                              je                            interrupt_insert_common
                              mov                           al, 081h
                              cmp                           ah, 089h
                              je                            interrupt_insert_common
                              mov                           al, 082h
                              cmp                           ah, 08ah
                              je                            interrupt_insert_common
                              mov                           al, 083h
                              cmp                           ah, 08bh
                              je                            interrupt_insert_common
                              mov                           al, 0a0h
                              cmp                           ah, 003h
                              je                            interrupt_insert_common
                              mov                           al, 0a1h
                              cmp                           ah, 013h
                              je                            interrupt_insert_common
                              mov                           al, 0a2h
                              cmp                           ah, 02bh
                              je                            interrupt_insert_common
                              mov                           al, 0a3h
                              cmp                           ah, 00bh
                              je                            interrupt_insert_common
                              mov                           al, 0e0h
                              cmp                           ah, 038h
                              je                            interrupt_insert_common
                              mov                           al, 0e1h
                              cmp                           ah, 039h
                              je                            interrupt_insert_common
                              mov                           al, 0e2h
                              cmp                           ah, 03ah
                              je                            interrupt_insert_common
                              mov                           al, 0e3h
                              cmp                           ah, 03bh
                              je                            interrupt_insert_common
                              add                           dl, 08h
                              mov                           al, 0c0h
                              cmp                           ah, 0c7h
                              je                            interrupt_insert_common
                              mov                           al, 0c1h
                              cmp                           ah, 0f7h
                              je                            interrupt_insert_common
                              jmp                           interrupt_insert_none
interrupt_insert_common:
IFDEF TEST_SETBREAK
                              call                          VMMMachineDump
ENDIF
                              pop                           edi
                              or                            dl, al
                              mov                           al, 0cch
                              stos                     byte ptr es:[edi]
                              mov                           al, dl
                              stos                     byte ptr es:[edi]
                              popad
                              clc
                              ret
interrupt_insert_none:
IFDEF TEST_SETBREAK
                              call                          VMMMachineDump
ENDIF
                              pop                           esi
                              popad
                              stc
                              ret
EndProc                       interrupt_insert

IFDEF TEST_CATCHFAULT
;====================================================================================================================================================;
;
; Tracing Services            VMMMachineDump traces the VxD
;                             V86MachineDump traces the V86 Client
;                             V86StackScan   dumps  the V86 Client Call Stack
;                             VMMStorageDump dumps  a   VMM Memory Area
;
;====================================================================================================================================================;

BeginProc                     VMMStorageDump
                              pushfd
                              pushad

                              push                          esi
                              push                          ecx

                              mov                           eax, R0_OPENCREATFILE
                              mov                           esi, OFFSET32 DumpFile
                              mov                           ebx, ACCESS_READWRITE + SHARE_DENYWRITE
                              xor                           ecx, ecx
                              mov                           edx, ACTION_OPENALWAYS
                              VxDCall                       IFSMgr_Ring0_FileIO
                              mov                           ebx, eax
                              mov                           eax, R0_GETFILESIZE
                              VxDCall                       IFSMgr_Ring0_FileIO

                              mov                           DumpOffset, eax
                              mov                           DumpHandle, ebx

                              pop                           ecx
                              pop                           esi
                              mov                           edx, OFFSET32 DumpVMM
VMMStorageDumpRow:
                              or                            ecx, ecx
                              jz                            VMMStorageDumpEnd
                              push                          esi
                              push                          ecx

                              push                          esi
                              mov                           edi, OFFSET32 DumpRow
                              mov                           esi, edx
                              mov                           ecx, 4
                          rep movs                     byte ptr es:[edi], byte ptr ds:[esi]
                              pop                           esi

                              push                          esi
                              mov                           edx, OFFSET32 DumpADR
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar
                              pop                           esi

                              xor                           edx, edx
VMMStorageDumpHByte:
                              mov                           al, [esi+edx]
                              shr                           al, 4
                              and                           al, 0fh
                              add                           al, 30h
                              cmp                           al, 3ah
                              jl                            VMMStorageDumpHByteLeft
                              add                           al, 07h
VMMStorageDumpHByteLeft: 
                              stos                     byte ptr es:[edi]
                              mov                           al, [esi+edx]
                              and                           al, 0fh
                              add                           al, 30h
                              cmp                           al, 3ah
                              jl                            VMMStorageDumpHByteRight
                              add                           al, 07h
VMMStorageDumpHByteRight:
                              stos                     byte ptr es:[edi]
                              inc                           edx
                              test                          dl, 03h
                              jnz                           VMMStorageDumpHByteSepar
                              mov                           al, 20h
                              stos                     byte ptr es:[edi]
VMMStorageDumpHByteSepar:
                              test                          dl, 1fh
                              jnz                           VMMStorageDumpHByte

                              mov                           al, 20h
                              stos                     byte ptr es:[edi]
                              mov                           al, 2ah
                              stos                     byte ptr es:[edi]
                              mov                           al, 20h
                              stos                     byte ptr es:[edi]

                              xor                           edx, edx
VMMStorageDumpCByte:
                              mov                           ah, [esi+edx]
                              mov                           al, 2eh
                              cmp                           ah, 20h
                              jl                            VMMStorageDumpCChar
                              cmp                           ah, 7eh
                              jg                            VMMStorageDumpCChar
                              mov                           al, ah
VMMStorageDumpCChar:
                              stos                     byte ptr es:[edi]
                              inc                           edx
                              test                          dl, 1fh
                              jnz                           VMMStorageDumpCByte

                              mov                           al, 0dh
                              stos                     byte ptr es:[edi]
                              mov                           al, 0ah
                              stos                     byte ptr es:[edi]

                              mov                           ecx, edi
                              sub                           ecx, OFFSET32 DumpRow
                              mov                           eax, R0_WRITEFILE
                              mov                           ebx, DumpHandle
                              mov                           edx, DumpOffset
                              mov                           esi, OFFSET32 DumpRow
                              VxDCall                       IFSMgr_Ring0_FileIO
                              add                           DumpOffset, eax

                              pop                           ecx
                              pop                           esi
                              mov                           edx, OFFSET32 DumpBLK
                              add                           esi, 00000020h
                              sub                           ecx, 00000020h
                              jns                           VMMStorageDumpRow
VMMStorageDumpEnd:
                              mov                           eax, R0_CLOSEFILE
                              mov                           ebx, DumpHandle
                              VxDCall                       IFSMgr_Ring0_FileIO

                              popad
                              popfd
                              ret
EndProc                       VMMStorageDump

BeginProc                     VMMMachineDump
                              pushfd
                              pushad
                              mov                           ebp, esp
                              mov                           eax, ds
                              push                          eax
                              mov                           eax, es
                              push                          eax
                              mov                           eax, fs
                              push                          eax
                              mov                           eax, gs
                              push                          eax
                              mov                           eax, cs
                              push                          eax
                              mov                           eax, ss
                              push                          eax

                              mov                           eax, R0_OPENCREATFILE
                              mov                           esi, OFFSET32 DumpFile
                              mov                           ebx, ACCESS_READWRITE + SHARE_DENYWRITE
                              xor                           ecx, ecx
                              mov                           edx, ACTION_OPENALWAYS
                              VxDCall                       IFSMgr_Ring0_FileIO
                              mov                           ebx, eax
                              mov                           eax, R0_GETFILESIZE
                              VxDCall                       IFSMgr_Ring0_FileIO

                              mov                           DumpOffset, eax
                              mov                           DumpHandle, ebx

                              mov                           edi, OFFSET32 DumpRow
                              mov                           esi, OFFSET32 DumpVMM
                              mov                           ecx, 4
                          rep movs                     byte ptr es:[edi], byte ptr ds:[esi]

                              mov                           esi, [ebp].Pushad_EAX
                              mov                           edx, OFFSET32 DumpEAX
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              mov                           esi, [ebp].Pushad_EBX
                              mov                           edx, OFFSET32 DumpEBX
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              mov                           esi, [ebp].Pushad_ECX
                              mov                           edx, OFFSET32 DumpECX
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              mov                           esi, [ebp].Pushad_EDX
                              mov                           edx, OFFSET32 DumpEDX
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              movzx                         esi, word ptr [ebp-0004h]
                              mov                           edx, OFFSET32 DumpDS
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpWORDSepar

                              movzx                         esi, word ptr [ebp-0008h]
                              mov                           edx, OFFSET32 DumpES
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpWORDSepar

                              movzx                         esi, word ptr [ebp-000ch]
                              mov                           edx, OFFSET32 DumpFS
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpWORDSepar

                              movzx                         esi, word ptr [ebp-0010h]
                              mov                           edx, OFFSET32 DumpGS
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpWORDSepar

                              movzx                         esi, word ptr [ebp-0014h]
                              mov                           edx, OFFSET32 DumpCS
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpWORDSepar

                              movzx                         esi, word ptr [ebp-0018h]
                              mov                           edx, OFFSET32 DumpSS
                              mov                           ecx, OFFSET32 DumpLine
                              call                          MachineDumpWORDSepar

                              mov                           esi, OFFSET32 DumpBLK
                              mov                           ecx, 4
                          rep movs                     byte ptr es:[edi], byte ptr ds:[esi]

                              mov                           esi, [ebp].Pushad_ESI
                              mov                           edx, OFFSET32 DumpESI
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              mov                           esi, [ebp].Pushad_EDI
                              mov                           edx, OFFSET32 DumpEDI
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              mov                           esi, [ebp].Pushad_EBP
                              mov                           edx, OFFSET32 DumpEBP
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              mov                           esi, [ebp].Pushad_ESP
                              mov                           edx, OFFSET32 DumpESP
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              mov                           esi, dword ptr [ebp+0020h]
                              mov                           edx, OFFSET32 DumpEFLAGS
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              mov                           esi, dword ptr [ebp+0024h]
                              mov                           edx, OFFSET32 DumpEIP
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              mov                           esi, OFFSET32 callback_type_run
                              mov                           edx, OFFSET32 DumpBAS
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              mov                           esi, OFFSET32 callback_type_run
                              lods                    dword ptr ds:[esi]
                              mov                           esi, eax
                              mov                           edx, OFFSET32 DumpINS
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              mov                           esi, OFFSET32 callback_type_run + 4
                              lods                    dword ptr ds:[esi]
                              mov                           esi, eax
                              mov                           edx, OFFSET32 DumpIN2
                              mov                           ecx, OFFSET32 DumpLine
                              call                          MachineDumpDWORDSepar

                              mov                           ecx, edi
                              sub                           ecx, OFFSET32 DumpRow
                              mov                           eax, R0_WRITEFILE
                              mov                           ebx, DumpHandle
                              mov                           edx, DumpOffset
                              mov                           esi, OFFSET32 DumpRow
                              VxDCall                       IFSMgr_Ring0_FileIO
                              add                           DumpOffset, eax

                              mov                           eax, R0_CLOSEFILE
                              mov                           ebx, DumpHandle
                              VxDCall                       IFSMgr_Ring0_FileIO

                              add                           esp, 0018h
                              popad
                              popfd
                              ret
EndProc                       VMMMachineDump

BeginProc                     V86MachineDump
                              pushfd
                              pushad
                              mov                           ebp, esp
                              mov                           eax, ds
                              push                          eax
                              mov                           eax, es
                              push                          eax
                              mov                           eax, fs
                              push                          eax
                              mov                           eax, gs
                              push                          eax
                              mov                           eax, cs
                              push                          eax
                              mov                           eax, ss
                              push                          eax

                              mov                           eax, R0_OPENCREATFILE
                              mov                           esi, OFFSET32 DumpFile
                              mov                           ebx, ACCESS_READWRITE + SHARE_DENYWRITE
                              xor                           ecx, ecx
                              mov                           edx, ACTION_OPENALWAYS
                              VxDCall                       IFSMgr_Ring0_FileIO
                              mov                           ebx, eax
                              mov                           eax, R0_GETFILESIZE
                              VxDCall                       IFSMgr_Ring0_FileIO

                              mov                           DumpOffset, eax
                              mov                           DumpHandle, ebx

                              mov                           edi, OFFSET32 DumpRow
                              mov                           esi, OFFSET32 DumpV86
                              mov                           ecx, 4
                          rep movs                     byte ptr es:[edi], byte ptr ds:[esi]

                              mov                           ebp, [ebp].Pushad_EBP

                              mov                           esi, [ebp].Client_EAX
                              mov                           edx, OFFSET32 DumpEAX
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              mov                           esi, [ebp].Client_EBX
                              mov                           edx, OFFSET32 DumpEBX
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              mov                           esi, [ebp].Client_ECX
                              mov                           edx, OFFSET32 DumpECX
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              mov                           esi, [ebp].Client_EDX
                              mov                           edx, OFFSET32 DumpEDX
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              movzx                         esi, [ebp].Client_DS
                              mov                           edx, OFFSET32 DumpDS
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpWORDSepar

                              movzx                         esi, [ebp].Client_ES
                              mov                           edx, OFFSET32 DumpES
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpWORDSepar

                              movzx                         esi, [ebp].Client_FS
                              mov                           edx, OFFSET32 DumpFS
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpWORDSepar

                              movzx                         esi, [ebp].Client_GS
                              mov                           edx, OFFSET32 DumpGS
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpWORDSepar

                              movzx                         esi, [ebp].Client_CS
                              mov                           edx, OFFSET32 DumpCS
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpWORDSepar

                              movzx                         esi, [ebp].Client_SS
                              mov                           edx, OFFSET32 DumpSS
                              mov                           ecx, OFFSET32 DumpLine
                              call                          MachineDumpWORDSepar

                              mov                           esi, OFFSET32 DumpBLK
                              mov                           ecx, 4
                          rep movs                     byte ptr es:[edi], byte ptr ds:[esi]

                              mov                           esi, [ebp].Client_ESI
                              mov                           edx, OFFSET32 DumpESI
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              mov                           esi, [ebp].Client_EDI
                              mov                           edx, OFFSET32 DumpEDI
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              mov                           esi, [ebp].Client_EBP
                              mov                           edx, OFFSET32 DumpEBP
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              mov                           esi, [ebp].Client_ESP
                              mov                           edx, OFFSET32 DumpESP
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              mov                           esi, [ebp].Client_EFlags
                              mov                           edx, OFFSET32 DumpEFLAGS
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              mov                           esi, [ebp].Client_EIP
                              mov                           edx, OFFSET32 DumpEIP
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              mov                           esi, VXD_ProgramBase
                              mov                           edx, OFFSET32 DumpBAS
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              movzx                         esi, word ptr [ebp].Client_EIP
                              movzx                         eax, word ptr [ebp].Client_CS
                              shl                           eax, 4
                              add                           esi, eax
                              sub                           esi, 4
                              lods                    dword ptr ds:[esi]
                              mov                           esi, eax
                              mov                           edx, OFFSET32 DumpINS
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              movzx                         esi, word ptr [ebp].Client_EIP
                              movzx                         eax, word ptr [ebp].Client_CS
                              shl                           eax, 4
                              add                           esi, eax
                              lods                    dword ptr ds:[esi]
                              mov                           esi, eax
                              mov                           edx, OFFSET32 DumpIN2
                              mov                           ecx, OFFSET32 DumpLine
                              call                          MachineDumpDWORDSepar

                              mov                           ecx, edi
                              sub                           ecx, OFFSET32 DumpRow
                              mov                           eax, R0_WRITEFILE
                              mov                           ebx, DumpHandle
                              mov                           edx, DumpOffset
                              mov                           esi, OFFSET32 DumpRow
                              VxDCall                       IFSMgr_Ring0_FileIO
                              add                           DumpOffset, eax

                              mov                           eax, R0_CLOSEFILE
                              mov                           ebx, DumpHandle
                              VxDCall                       IFSMgr_Ring0_FileIO

                              add                           esp, 0018h
                              popad
                              popfd
                              ret
EndProc                       V86MachineDump

BeginProc                     V86StackScan
                              pushfd
                              pushad
                              mov                           ebp, esp
                              mov                           eax, ds
                              push                          eax
                              mov                           eax, es
                              push                          eax
                              mov                           eax, fs
                              push                          eax
                              mov                           eax, gs
                              push                          eax
                              mov                           eax, cs
                              push                          eax
                              mov                           eax, ss
                              push                          eax

                              mov                           eax, R0_OPENCREATFILE
                              mov                           esi, OFFSET32 DumpFile
                              mov                           ebx, ACCESS_READWRITE + SHARE_DENYWRITE
                              xor                           ecx, ecx
                              mov                           edx, ACTION_OPENALWAYS
                              VxDCall                       IFSMgr_Ring0_FileIO
                              mov                           ebx, eax
                              mov                           eax, R0_GETFILESIZE
                              VxDCall                       IFSMgr_Ring0_FileIO

                              mov                           DumpOffset, eax
                              mov                           DumpHandle, ebx

                              mov                           ebp, [ebp].Pushad_EBP

                              movzx                         esi, [ebp].Client_SS
                              shl                           esi, 4
                              movzx                         eax, word ptr [ebp].Client_EBP
                              add                           esi, eax
                              mov                           DumpFrame, esi

                              mov                           si, [ebp].Client_SS
                              shl                           esi, 16
                              mov                           si, ax

                              mov                           edx, OFFSET32 DumpV86
V86StackScanRow:
                              push                          esi
                              mov                           edi, OFFSET32 DumpRow
                              mov                           ecx, 4
                              mov                           esi, edx
                          rep movs                     byte ptr es:[edi], byte ptr ds:[esi]
                              pop                           esi

                              mov                           eax, DumpFrame
                              movzx                         esi, word ptr [eax+00h]
                              mov                           edx, OFFSET32 DumpEBP + 1
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpWORDSepar

                              mov                           eax, DumpFrame
                              movzx                         esi, [ebp].Client_SS
                              mov                           edx, OFFSET32 DumpSS
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpWORDSepar

                              mov                           eax, DumpFrame
                              movzx                         esi, [ebp].Client_SS
                              shl                           esi, 4
                              sub                           esi, VXD_ProgramBase
                              shr                           esi, 4
                              mov                           edx, OFFSET32 DumpSS
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpWORDSepar

                              mov                           eax, DumpFrame
                              movzx                         esi, word ptr [eax+02h]
                              mov                           edx, OFFSET32 DumpEIP + 1
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpWORDSepar

                              mov                           eax, DumpFrame
                              movzx                         esi, word ptr [eax+04h]
                              mov                           edx, OFFSET32 DumpCS
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpWORDSepar

                              mov                           eax, DumpFrame
                              movzx                         esi, word ptr [eax+04h]
                              shl                           esi, 4
                              sub                           esi, VXD_ProgramBase
                              shr                           esi, 4
                              mov                           edx, OFFSET32 DumpCS
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpWORDSepar

                              mov                           eax, DumpFrame
                              movzx                         esi, word ptr [eax+04h]
                              shl                           esi, 4
                              movzx                         eax, word ptr [eax+02h]
                              add                           esi, eax
                              
                              cmp                      byte ptr [esi+00h], 083h
                              jne                           V86StackScanNext
                              cmp                      byte ptr [esi+01h], 0c4h
                              jne                           V86StackScanNext
                              movzx                         ecx, byte ptr [esi+02h]
                              shr                           ecx, 1
                              mov                           edx, 00000006h
V86StackScanLoop:
                              push                          edx
                              push                          ecx

                              mov                           eax, DumpFrame
                              movzx                         esi, word ptr [eax+edx]
                              mov                           edx, OFFSET32 DumpARG
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpWORDSepar

                              pop                           ecx
                              pop                           edx

                              mov                           eax, DumpFrame
                              movzx                         esi, word ptr [eax+edx]
                              cmp                           si, [ebp].Client_SS
                              jne                           V86StackScanNInt

                              push                          edx
                              push                          ecx

                              mov                           eax, DumpFrame
                              movzx                         eax, word ptr [eax+edx-02h]
                              shl                           esi, 4
                              add                           esi, eax
                              mov                           esi, dword ptr [esi]
                              mov                           edx, OFFSET32 DumpARG
                              mov                           ecx, OFFSET32 DumpSepar
                              call                          MachineDumpDWORDSepar

                              pop                           ecx
                              pop                           edx
V86StackScanNInt:
                              inc                           edx
                              inc                           edx
                              loop                          V86StackScanLoop
V86StackScanNext:
                              mov                           al, 0dh
                              mov                      byte ptr [edi-2], al
                              mov                           al, 0ah
                              mov                      byte ptr [edi-1], al
                              mov                           ecx, edi
                              sub                           ecx, OFFSET32 DumpRow
                              mov                           eax, R0_WRITEFILE
                              mov                           ebx, DumpHandle
                              mov                           edx, DumpOffset
                              mov                           esi, OFFSET32 DumpRow
                              VxDCall                       IFSMgr_Ring0_FileIO
                              add                           DumpOffset, eax

                              mov                           edx, OFFSET32 DumpBLK

                              movzx                         esi, [ebp].Client_SS
                              shl                           esi, 4
                              mov                           eax, DumpFrame
                              movzx                         eax, word ptr [eax+00h]
                              add                           esi, eax
                              cmp                           esi, DumpFrame
                              jna                           V86StackScanEnd
                              mov                           DumpFrame, esi
                              movzx                         esi, word ptr [esi+00h]
                              or                            esi, esi
                              jz                            V86StackScanEnd

                              mov                           si, [ebp].Client_SS
                              shl                           esi, 16
                              mov                           si, ax
                              jmp                           V86StackScanRow
V86StackScanEnd:
                              mov                           eax, R0_CLOSEFILE
                              mov                           ebx, DumpHandle
                              VxDCall                       IFSMgr_Ring0_FileIO

                              add                           esp, 0018h
                              popad
                              popfd
                              ret
EndProc                       V86StackScan

BeginProc                     MachineDumpDWORDSepar
                              push                          ecx
                              push                          esi
                              mov                           esi, edx
                              mov                           ecx, 3
                          rep movs                     byte ptr es:[edi], byte ptr ds:[esi]
                              pop                           esi
                              call                          MachineDumpDWORD
                              pop                           esi
                              mov                           ecx, 2
                          rep movs                     byte ptr es:[edi], byte ptr ds:[esi]
                              ret
EndProc                       MachineDumpDWORDSepar

BeginProc                     MachineDumpWORDSepar
                              push                          ecx
                              push                          esi
                              mov                           esi, edx
                              mov                           ecx, 2
                          rep movs                     byte ptr es:[edi], byte ptr ds:[esi]
                              pop                           esi
                              call                          MachineDumpWORD
                              pop                           esi
                              mov                           ecx, 2
                          rep movs                     byte ptr es:[edi], byte ptr ds:[esi]
                              ret
EndProc                       MachineDumpWORDSepar

BeginProc                     MachineDumpDWORD
                              push                          edi
                              mov                           ecx, 0020h
                              mov                           edi, OFFSET32 DumpBuffer + 3
MachineDumpDWORDLoop:
                              jecxz                         MachineDumpDWORDWrite
                              sub                           cl, 04h
                              mov                           eax, esi
                              shr                           eax, cl
                              and                           al, 0fh
                              add                           al, 30h
                              cmp                           al, 3ah
                              jl                            MachineDumpDWORDDigit
                              add                           al, 07h
MachineDumpDWORDDigit:
                              stos                     byte ptr es:[edi]
                              jmp                           MachineDumpDWORDLoop
MachineDumpDWORDWrite:
                              pop                           edi
                              mov                           ecx, 000bh
                              mov                           esi, OFFSET32 DumpBuffer
                          rep movs                     byte ptr es:[edi], byte ptr ds:[esi]
                              ret
EndProc                       MachineDumpDWORD

BeginProc                     MachineDumpWORD
                              push                          edi
                              mov                           ecx, 0010h
                              mov                           edi, OFFSET32 DumpBuffer + 3
MachineDumpWORDLoop:
                              jecxz                         MachineDumpWORDWrite
                              sub                           cl, 04h
                              mov                           eax, esi
                              shr                           eax, cl
                              and                           al, 0fh
                              add                           al, 30h
                              cmp                           al, 3ah
                              jl                            MachineDumpWORDDigit
                              add                           al, 07h
MachineDumpWORDDigit:
                              stos                     byte ptr es:[edi]
                              jmp                           MachineDumpWORDLoop
MachineDumpWORDWrite:
                              pop                           edi
                              mov                           ecx, 0007h
                              mov                           esi, OFFSET32 DumpBuffer
                          rep movs                     byte ptr es:[edi], byte ptr ds:[esi]
                              ret
EndProc                       MachineDumpWORD
ENDIF

VXD_LOCKED_CODE_ENDS

;====================================================================================================================================================;
;                                D E V I C E                 I N I T I A L I Z A T I O N   C O D E
;====================================================================================================================================================;

VXD_ICODE_SEG

;====================================================================================================================================================;
;
; U7VXD_Device_Init - U7VXD Initialization
;
;
; Entry:                      EBX -> System VM handle
;                             EDX -> Reference data from real mode init portion
;
; Exit: If successful         then   Carry flag is clear
;                             else   Carry flag is set to indicate an error -- Device not initialized
;
;====================================================================================================================================================;

BeginProc                     U7VXD_Device_Init

IFDEF TRACE
                              call                          VMMMachineDump
ENDIF
                              mov                           VXD_VMHandle, ebx
IFDEF TEST_NONNULLDS
                              push                          0
                              push                          1
                              push                          0000FFFFh                               ; EAX = base_1:base_0            :limit_1:limit_0
                              push                          004F9200h                               ; EDX = base_3:attributes/limit_2:type   :base_2
                              push                          ebx
                              VMMCall                       _Allocate_LDT_Selector
                              add                           esp, 14h
                              mov                           VXD_GS_PM, ax
IFDEF TRACE
                              call                          VMMMachineDump
ENDIF
ENDIF
                              mov                           esi, OFFSET32 U7VXD_Break_Hook
                              mov                           eax, 3
                              VMMCall                       Hook_V86_Int_Chain
IFDEF TEST_CATCHFAULT
                              mov                           esi, OFFSET32 U7VXD_PageFault_Hook
                              VMMCall                       Hook_Invalid_Page_Fault
ENDIF
                              mov                           VXD_VMHandle, ebx
IFDEF TRACE
                              call                          VMMMachineDump
ENDIF
                              clc
                              ret

EndProc                       U7VXD_Device_Init

VXD_ICODE_ENDS
                              end
